{--------------------------------------------------------------------------
 | Copyright (C) 1992 - 2003 Dallas Semiconductor MAXIM Corporation.
 | All rights Reserved. Printed in U.S.A.
 | This software is protected by copyright laws of
 | the United States and of foreign countries.
 | This material may also be protected by patent laws of the United States
 | and of foreign countries.
 | This software is furnished under a license agreement and/or a
 | nondisclosure agreement and may only be used or copied in accordance
 | with the terms of those agreements.
 | The mere transfer of this software does not imply any licenses
 | of trade secrets, proprietary technology, copyrights, patents,
 | trademarks, maskwork rights, or any other form of intellectual
 | property whatsoever. Dallas Semiconductor MAXIM retains all ownership rights.
 |--------------------------------------------------------------------------

   Thermochron viewer
 }
unit TRecUn;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, iBTMEXPW, ComCtrls, Tabnotbk, Menus, Clipbrd,
  ChartUn;

type
  TTRecForm = class(TForm)
    TopPanel: TPanel;
    OneWireLabel: TLabel;
    WLabel: TLabel;
    FlashPanel: TPanel;
    GreenLight: TShape;
    BottomPanel: TPanel;
    PortLabel: TLabel;
    CenterPanel: TPanel;
    RecTab: TTabbedNotebook;
    LeftPanel: TPanel;
    Wizard: TNotebook;
    IntroLabel: TLabel;
    SetTimeCheck: TCheckBox;
    NextButton: TButton;
    Bevel1: TBevel;
    BackButton: TButton;
    FinishButton: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Image1: TImage;
    TRecTimer: TTimer;
    Label4: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    AlarmTimeCombo: TComboBox;
    HidePanel: TPanel;
    AlarmLabel: TLabel;
    DayLabel: TLabel;
    HourLabel: TLabel;
    MinuteLabel: TLabel;
    SecondLabel: TLabel;
    AlarmSecond: TComboBox;
    AlarmMinute: TComboBox;
    AlarmHour: TComboBox;
    AlarmDay: TComboBox;
    DelayDay: TComboBox;
    Label10: TLabel;
    DelayHour: TComboBox;
    Label11: TLabel;
    DelayMinute: TComboBox;
    Label12: TLabel;
    TotalMinutesLabel: TLabel;
    Label14: TLabel;
    Label13: TLabel;
    PCTimeLabel: TLabel;
    TRecTimeLabel: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    SampleMinutes: TComboBox;
    Label22: TLabel;
    Label23: TLabel;
    HighThreshold: TComboBox;
    LowThreshold: TComboBox;
    Label24: TLabel;
    Label25: TLabel;
    StatusPanel: TPanel;
    Status: TLabel;
    DegreeLabel: TLabel;
    ConditionalOnTimeCheck: TCheckBox;
    ConditionalOnTempHighCheck: TCheckBox;
    ConditionalOnTempLowCheck: TCheckBox;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    RolloverDays: TLabel;
    RolloverCheck: TCheckBox;
    Label29: TLabel;
    Label30: TLabel;
    FinishPanel: TPanel;
    FinishMemo: TMemo;
    MissionGroup: TGroupBox;
    TempGroup: TGroupBox;
    TimeGroup: TGroupBox;
    Label31: TLabel;
    MissionStatus: TLabel;
    Label32: TLabel;
    MissionStartLabel: TLabel;
    Label34: TLabel;
    MissionDelayLabel: TLabel;
    Label36: TLabel;
    MissionSamplesLabel: TLabel;
    ForceButton: TButton;
    ForceTempLabel: TLabel;
    Label33: TLabel;
    HighThresholdLabel: TLabel;
    LowThresholdLabel: TLabel;
    Label40: TLabel;
    Label35: TLabel;
    CurrentTimeLabel: TLabel;
    AlarmModeLabel: TLabel;
    Label41: TLabel;
    TimeAlarmSettingLabel: TLabel;
    Label43: TLabel;
    TempAlarmLabel: TLabel;
    TimeAlarmLabel: TLabel;
    Label37: TLabel;
    RolloverEnableLabel: TLabel;
    RolloverOccuredLabel: TLabel;
    Label44: TLabel;
    DeviceCountLabel: TLabel;
    Label38: TLabel;
    SampleRateLabel: TLabel;
    Label42: TLabel;
    LogBox: TGroupBox;
    AlarmBox: TGroupBox;
    ViewOptionsBox: TGroupBox;
    HistogramBox: TGroupBox;
    ReadButton: TButton;
    ExportButton: TButton;
    LogList: TListBox;
    GraphLogButton: TButton;
    GraphHistButton: TButton;
    HistList: TListBox;
    AlarmList: TListBox;
    LogRadio: TRadioGroup;
    HistRadio: TRadioGroup;
    SaveDialog: TSaveDialog;
    LogSyntax: TLabel;
    HistSyntax: TLabel;
    MainMenu: TMainMenu;
    MenuItem: TMenuItem;
    MenuExportToClip: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuDebugDump: TMenuItem;
    N2: TMenuItem;
    MenuFahrenheit: TMenuItem;
    MenuCelsius: TMenuItem;
    MenuShowFC: TMenuItem;
    N1: TMenuItem;
    MenuStopMission: TMenuItem;
    MenuAutoExport: TMenuItem;
    MenuHelp: TMenuItem;
    RadioGroupDelimiters: TRadioGroup;
    LabelTempRange: TLabel;
    LabelTRange: TLabel;
    MemoWarning: TMemo;
    procedure NoDevice(state : Boolean);
    Function  VerifyDevice: SmallInt;
    Procedure GetSizePos;
    Procedure Light(state : Boolean);
    Function  ReallyGone: Boolean;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    Procedure SetStatus(StatusString : String);
    procedure TRecTimerTimer(Sender: TObject);
    procedure MenuExitClick(Sender: TObject);
    procedure NextButtonClick(Sender: TObject);
    procedure BackButtonClick(Sender: TObject);
    procedure AlarmTimeComboChange(Sender: TObject);
    procedure DelayDayChange(Sender: TObject);
    procedure CreateThresholds;
    procedure MenuFahrenheitClick(Sender: TObject);
    procedure MenuCelsiusClick(Sender: TObject);
    procedure SampleMinutesChange(Sender: TObject);
    procedure UpdateFinishStatement;
    Function  ReadPage(Page: SmallInt; DataP : PByte): SmallInt;
    procedure UpdateStatus;
    Function  BCD(BCDToConvert : Byte; Position : SmallInt): Char;
    procedure ForceButtonClick(Sender: TObject);
    Function  BCDTimeToString(Time : PChar; HaveSeconds, is2000 : Boolean; Var ReturnString : String): TDateTime;
    procedure RecTabChange(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure GraphLogButtonClick(Sender: TObject);
    procedure GraphHistButtonClick(Sender: TObject);
    procedure UpdateLog;
    procedure UpdateAlarms;
    procedure UpdateHistogram;
    procedure LogRadioClick(Sender: TObject);
    procedure HistRadioClick(Sender: TObject);
    procedure ReadButtonClick(Sender: TObject);
    procedure ExportButtonClick(Sender: TObject);
    procedure FinishButtonClick(Sender: TObject);
    Function  ToBCD(NumToConvert : SmallInt): Byte;
    procedure CreateWriteStatus;
    Function  ClearMemory: SmallInt;
    Function  WriteMission: SmallInt;
    Function  WriteScratch(Buf : PChar; ln,adr : SmallInt) : SmallInt;
    Function  CopyScratch(ln,adr : SmallInt) : SmallInt;
    procedure MenuDebugDumpClick(Sender: TObject);
    procedure ExportData(ToClipboard : Boolean);
    procedure MenuExportToClipClick(Sender: TObject);
    procedure MenuShowFCClick(Sender: TObject);
    procedure MenuStopMissionClick(Sender: TObject);
    Function  StopMission: SmallInt;
    Function  ForceConversion: SmallInt;
    Function  ConvertToInt(Buf : PChar; Def: LongInt): LongInt;
    procedure ShowTimeAlarm;
    procedure ChangeTempScale;
    procedure MenuAutoExportClick(Sender: TObject);
    procedure MenuHelpClick(Sender: TObject);
    procedure RadioGroupDelimitersClick(Sender: TObject);
    procedure UpdateLabels;
    procedure FormShow(Sender: TObject);
    function  FindFirstFamily(family: SmallInt; Var ROMStr: String): SmallInt;
    procedure DisplayThermoType;
  private
    { Private declarations }
  public
    { Public declarations }
    PortType,PortNum: SmallInt;  { Port Number and Type }
    StateBuf : Pointer;          { TMEX state buffer }
    SHandle : LongInt;           { TMEX Session handle }
    GotBuf : Boolean;            { flag got TMEX state buffer }
    ROM : array[0..8] of SmallInt; { array of rom number }
    LTop,LLeft : SmallInt;       { last size/pos values }
    DoResize : Boolean;          { flag to do custom resize once }
    AutoClose : Boolean;         { flag to auto close on no device }
    AutoPosition : Boolean;      { auto save size/postion }
    DeviceGone: Boolean;         { flag to indicate device is gone }
    FlashTime : LongInt;         { time to flash device gone }
    DidSetup : Boolean;          { flag if did setup }

    ErrorCnt : SmallInt;         { count of errors in a row }
    ErrorType : SmallInt;        { type of repeated errors }

    DisableEvents : Boolean;     { true if forcing settings to supress change events }
    FastScan : Boolean;          { true during fast scan }
    DelayMinutes : LongInt;      { number of delay minutes }
    AppName : Array[0..50] of Char;
    { state }
    TRecMode : SmallInt;         { TRec mode }
    WriteMissionMode : SmallInt; { Write Mission mode }
    PageToRead : SmallInt;       { current page to read }
    // !!!
    //MissionCount : LongInt;      { number of samples in current mission }
    //LastMissionCount : LongInt;  { samples during last data read }
    MissionCount : Int64;        { number of samples in current mission }
    LastMissionCount : Int64;    { samples during last data read }
    // !!!
    DownloadTimeDate : TDateTime; { time of download }
    SampleRate : SmallInt;       { number of minutes between readings }
    DeviceCount : LongInt;       { number of total samples by device }
    ClockAlarmMode : SmallInt;   { time alarm mode }
    MissionDelay : LongInt;      { number of minutes to delay start of mission }
    OnGoingMission : Boolean;    { true if there is currently an ongoing mission }
    MissionStartDT : TDateTime;  { date/time of mission start }
    LastStatusTime : LongInt;    { last time status/time was read }
    DidConversion : Boolean;     { flag to indicate there was a force conversion }
    HighTrip,LowTrip : Real;     { last high/low threshold trip values }
    DoAutoExport : Boolean;      { flag to indicate if it is ok to do an autoexport }

    { results }
    StatusBuf : array[0..32] of Byte;     { array containing the current status }
    WriteStatusBuf : array[0..32] of Byte;{ array containing the new status }
    TempLog : array[0..2048] of Byte;  { array of temperature log readings }
    Histogram : array[0..128] of Byte; { array of temperature histogram }
    TempAlarms : array[0..96] of Byte; { array of temperature alarms }
    HistData: array[0..63] of LongInt; { array to hold recent histogram data }
    LogData: array[0..2048] of Real;   { array to hold recent log data }

    { miscellaneous }
    Delimiter : String;  { A data delimiter -- either a comma or semicolon }
    TempRangeHigh : Integer; { Thermochron's High temperature range limit in Celsius -- 85 C }
    TempRangeLow : Integer;  { Thermochron's Low temperature range limit in degrees Celsius }
    TempResolution : Real;  { Thermochrons temperature resolution }
    TempZero : Real;     { Thermochrons temperature formula offset }
  end;

var
  TRecForm: TTRecForm;
  
Const
   { modes }
   TREC_SETUP = 0;
   TREC_FIND_THERMO = 1;
   TREC_CHECK_MISSION = 2;
   TREC_READ_ALARM = 3;
   TREC_READ_HIST = 4;
   TREC_READ_LOG = 5;
   TREC_VERIFY = 6;
   TREC_READTIME = 7;
   TREC_CLEAR_MEM = 8;
   TREC_CLEAR_VERIFY = 9;
   TREC_WRITE_MISSION = 10;
   TREC_STOP_MISSION = 11;
   TREC_DO_CONVERSION = 12;
   { write mission sub modes }
   WM_WRITE_TIME = 0;
   WM_WRITE_CONTROL = 1;
   WM_WRITE_SAMPLE = 2;
   { return codes }
   TRECIN_PROGRESS = 2;
   TRECDONE = 4;
   TRECSUCCESS = 1;
   TRECNO_DEVICE = -1;
   TRECNO_SESSION = -200;
   TREC_COMERROR = -300;
   TREC_WRITE_ERR = -301;
   { other }
   FAST_SCAN = 50;
   SLOW_SCAN = 500;
   TIME_READ_INTERVAL = 3000;
   MaxAvail = 45000;
   { pages }
   STATUS_PAGE = 16;
   START_ALARMS_PAGE = 17;
   END_ALARMS_PAGE = 19;
   START_HIST_PAGE = 64;
   END_HIST_PAGE = 67;
   START_LOG_PAGE = 128;
   END_LOG_PAGE = 191;
   { alarm modes }
   ALARM_SECOND = 5;
   ALARM_MINUTELY = 4;
   ALARM_HOURLY = 3;
   ALARM_DAILY = 2;
   ALARM_WEEKLY = 1;
   { days of week strings }
   Days: array[0..7] of String = ('', 'Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday',
                       'Friday', 'Saturday');
   { tabs }
   TAB_WIZARD = 0;
   TAB_RESULT = 1;
   TAB_STATUS = 2;

implementation

{$R *.DFM}


{----------------------------------------------------------------------------}
{ Initialization for this entitiy
}
procedure TTRecForm.FormCreate(Sender: TObject);
Var
   i : SmallInt;
   pc : PChar;
begin
   { get the TMEX state buffer for this form }

   If (MaxAvail <= REG_STATE_BUF) Then
   Begin
      ShowMessage('ERROR, not enough memory to create this form!');
      GotBuf := False;
      Application.Terminate;
   End
   Else
   Begin
      GetMem(StateBuf,REG_STATE_BUF);
      GotBuf := True;
      { zero the new state buffer }
      pc := StateBuf;
      For i := 0 to REG_STATE_BUF-1 Do
         pc[i] := Chr(0);
   End;

   { setup initial values }
   StrPCopy(AppName,'Thermochron Viewer');
   TRecMode := TREC_SETUP;
   DidSetup := False;

   OnGoingMission := False;
   DisableEvents := False;

   { read the port and type of 1-Wire }
   If (TMReadDefaultPort(@PortNum, @PortType) <> 1) Then
   Begin
      Application.MessageBox('Default 1-Wire Net not found',
               AppName, mb_OK + mb_IconExclamation + mb_ApplModal);
      Application.Terminate;
   End;

   PortLabel.Caption := 'Port: ' + IntToStr(PortNum) + '(num),' +
                         IntToStr(PortType) + '(type)';

   { start the timer in fast mode }
   FastScan := True;
   TRecTimer.Interval := FAST_SCAN;
   TRecTimer.Enabled := True;
   DidConversion := False;
   DoAutoExport := True;

   { set the initial directory to the executables directory }
   SaveDialog.InitialDir := ExtractFilePath(Application.ExeName);
   TRecForm.Visible := True;
end;

{----------------------------------------------------------------------------}
{ Work event
}
procedure TTRecForm.TRecTimerTimer(Sender: TObject);
Var
   flag : SmallInt;
   // !!!
   MissionCountFlag : Int64;
   // !!!
   cstr  : Array[0..256] of Char;
   tstr : String;
   ROMStr : String;
begin
   TRecTimer.Enabled := False;

   { setup connected }
   If (TRECMode = TREC_SETUP) Then
   Begin
      SetStatus('Setup Window');
      { set defaults }
      AlarmTimeCombo.ItemIndex := 0;
      AlarmDay.ItemIndex := 0;
      AlarmHour.ItemIndex := 0;
      AlarmMinute.ItemIndex := 0;
      AlarmSecond.ItemIndex := 0;
      DelayDay.ItemIndex := 0;
      DelayHour.ItemIndex := 0;
      DelayMinute.ItemIndex := 0;
      TRecTimeLabel.Caption := '';
      PCTimeLabel.Caption := '';
      CreateThresholds;
      HighThreshold.ItemIndex := HighThreshold.Items.Count - 1;
      LowThreshold.ItemIndex := 0;
      SampleMinutes.ItemIndex := 0;
      Wizard.PageIndex := 0;
      RolloverDays.Caption := '1.4 Days';

      TRECMode := TREC_FIND_THERMO;

      { initialize components V3.20 release }
      AlarmBox.Visible := False;
      HistogramBox.Visible := False;
      LogBox.Visible := False;
      MemoWarning.Visible := False;
   End
   { search to find a Thermochron on the default 1-Wire }
   Else If (TRECMode = TREC_FIND_THERMO) Then
   Begin
      SetStatus('Waiting for Thermochron...');
      { find the first DS1921 on the MicroLan }
      flag := FindFirstFamily($21,ROMStr);
      If (flag = TRECSUCCESS) Then
      Begin
         SetStatus('Thermochron found, ' + ROMStr);
         TRecForm.Caption := ROMStr;
         TRecForm.DisplayThermoType;
         TRECMode := TREC_CHECK_MISSION;
      End
      Else If (flag = TRECNO_DEVICE) Then
         NoDevice(True)
      { other error }
      Else If ((flag < 0) And (flag <> TRECNO_SESSION)) Then
      Begin
         SetStatus('Find Thermochron error: ' + IntToStr(flag));
      End;
   End
   { read the state to see if mission going on }
   Else If ((TRECMode = TREC_CHECK_MISSION) Or (TRECMode = TREC_READTIME)) Then
   Begin
      If (TRECMode = TREC_READTIME) Then
         SetStatus('Read time')
      Else
         SetStatus('Read Status page');
      { read the status page to get mission status }
      flag := ReadPage(STATUS_PAGE,@StatusBuf[0]);
      If (flag = TRECSUCCESS) Then
      Begin
         LastStatusTime := GetTickCount;
         If (TRECMode = TREC_READTIME) Then
         Begin
            SetStatus('Read time: Success');
            UpdateStatus;
            { slow scan on verify }
            TRECMode := TREC_VERIFY;
            FastScan := False;
            TRecTimer.Interval := SLOW_SCAN;
            If (Not OnGoingMission) Then
            Begin
               ForceButton.Enabled := True;
               ForceTempLabel.Visible := True;
            End
            Else
            Begin
               ForceButton.Enabled := False;
               ForceTempLabel.Visible := False;
            End;
         End
         Else
         Begin
            SetStatus('Read Status page: Success');
            { interpret the data in the status page }
            UpdateStatus;
            { check on the number of Mission Samples }
            If (Not OnGoingMission) Then
            Begin
               { no mission }
               { set to the mission tab }
               DisableEvents := True;
               RecTab.PageIndex := 0;
               Wizard.PageIndex := 0;
               DisableEvents := False;
               RecTab.Visible := True;
               { go into slow verify while filling out wizard }
               TRECMode := TREC_VERIFY;
               FastScan := False;
               TRecTimer.Interval := SLOW_SCAN;
               { check if any old data left }
               If (MissionCount > 0) Then
                  ReadButton.Enabled := True;
               ForceButton.Enabled := True;
               ForceTempLabel.Visible := True;
            End
            Else
            Begin
               { mission results available }
               { set to the status tab while reading results }
               DisableEvents := True;
               If (MenuAutoExport.Checked And DoAutoExport) Then
                  RecTab.PageIndex := 1
               Else
                  RecTab.PageIndex := 2;
               DisableEvents := False;
               RecTab.Visible := True;
               { read the data, start with alarms }
               TRECMode := TREC_READ_ALARM;
               PageToRead := START_ALARMS_PAGE;
               { mark this time as the download time }
               DownloadTimeDate := Now;
               ForceButton.Enabled := False;
               ForceTempLabel.Visible := False;
            End;
         End;
      End
      Else If (flag = TRECNO_DEVICE) Then
         NoDevice(True)
      { other error }
      Else If ((flag < 0) And (flag <> TRECNO_SESSION)) Then
      Begin
         SetStatus('Read Status page: error ' + IntToStr(ErrorType));
         { count consistent errors }
         If (ErrorType <> flag) Then
         Begin
            ErrorCnt := 0;
            ErrorType := flag;
         End
         Else
            Inc(ErrorCnt);

         { if long string of errors, then report }
         If (ErrorCnt > 10) Then
         Begin
            ErrorCnt := 0;
            MessageBeep(MB_OK);
            tstr := 'Error reading status page (' + IntToStr(ErrorType) + ')!';
            Application.MessageBox(StrPCopy(cstr,tstr),
                       AppName, mb_OK + mb_IconExclamation + mb_ApplModal);
         End;
      End;
   End
   { read the alarms results from mission }
   Else If (TRECMode = TREC_READ_ALARM) Then
   Begin
      SetStatus('Read Alarm page: ' + IntToStr(PageToRead));
      { read the status page to get mission status }
      flag := ReadPage(PageToRead,@TempAlarms[(PageToRead - START_ALARMS_PAGE) * 32]);
      If (flag = TRECSUCCESS) Then
      Begin
         SetStatus('Read Alarm page: ' + IntToStr(PageToRead) + ' Success');
         { got to the next page }
         Inc(PageToRead);
         If (PageToRead > END_ALARMS_PAGE) Then
         Begin
            { done }
            { interpret the alarms }
            UpdateAlarms;
            { now read the histogram }
            TRECMode := TREC_READ_HIST;
            PageToRead := START_HIST_PAGE;
         End;
      End
      Else If (flag = TRECNO_DEVICE) Then
         NoDevice(True)
      { other error }
      Else If ((flag < 0) And (flag <> TRECNO_SESSION)) Then
      Begin
         SetStatus('Read Alarm page: ' + IntToStr(PageToRead) + ' Error ' + IntToStr(ErrorType));
         { count consistent errors }
         If (ErrorType <> flag) Then
         Begin
            ErrorCnt := 0;
            ErrorType := flag;
         End
         Else
            Inc(ErrorCnt);

         { if long string of errors, then report }
         If (ErrorCnt > 10) Then
         Begin
            ErrorCnt := 0;
            MessageBeep(MB_OK);
            tstr := 'Error reading temperature alarm page (' + IntToStr(ErrorType) + ')!';
            Application.MessageBox(StrPCopy(cstr,tstr),
                       AppName, mb_OK + mb_IconExclamation + mb_ApplModal);
         End;
      End;
   End
   { read the histogram results }
   Else If (TRECMode = TREC_READ_HIST) Then
   Begin
      SetStatus('Read Histogram page: ' + IntToStr(PageToRead));
      { read the histogram page }
      flag := ReadPage(PageToRead,@Histogram[(PageToRead - START_HIST_PAGE) * 32]);
      If (flag = TRECSUCCESS) Then
      Begin
         SetStatus('Read Histogram page: ' + IntToStr(PageToRead) + ' Success');
         { got to the next page }
         Inc(PageToRead);
         If (PageToRead > END_HIST_PAGE) Then
         Begin
            { done }
            { interpret the histogram }
            UpdateHistogram;
            { now read the log }
            TRECMode := TREC_READ_LOG;
            PageToRead := START_LOG_PAGE;
         End;
      End
      Else If (flag = TRECNO_DEVICE) Then
         NoDevice(True)
      { other error }
      Else If ((flag < 0) And (flag <> TRECNO_SESSION)) Then
      Begin
         SetStatus('Read Histogram page: ' + IntToStr(PageToRead) + ' Error ' + IntToStr(ErrorType));
         { count consistent errors }
         If (ErrorType <> flag) Then
         Begin
            ErrorCnt := 0;
            ErrorType := flag;
         End
         Else
            Inc(ErrorCnt);

         { if long string of errors, then report }
         If (ErrorCnt > 10) Then
         Begin
            ErrorCnt := 0;
            MessageBeep(MB_OK);
            tstr := 'Error reading histogram page (' + IntToStr(ErrorType) + ')!';
            Application.MessageBox(StrPCopy(cstr,tstr),
                       AppName, mb_OK + mb_IconExclamation + mb_ApplModal);
         End;
      End;
   End
   { read the log results }
   Else If (TRECMode = TREC_READ_LOG) Then
   Begin
      SetStatus('Read Log page: ' + IntToStr(PageToRead));
      { read the histogram page }
      flag := ReadPage(PageToRead,@TempLog[(PageToRead - START_LOG_PAGE) * 32]);
      If (flag = TRECSUCCESS) Then
      Begin
         SetStatus('Read Log page: ' + IntToStr(PageToRead) + ' Success');
         { go to the next page }
         Inc(PageToRead);
         { calculate the real end of data }
         // !!!
         //flag := MissionCount div 32;
         MissionCountFlag := MissionCount div 32;
         //If ((MissionCount mod 32) > 0) Then
         //   Inc(flag);
         If ((MissionCount mod 32) > 0) Then
            Inc(MissionCountFlag);
         //If (flag > 64) Then
         //   flag := 64;
         //flag := flag + START_LOG_PAGE;
         //If ((PageToRead > END_LOG_PAGE) Or (PageToRead > flag)) Then

         If (MissionCountFlag > 64) Then
            MissionCountFlag := 64;
         MissionCountFlag := MissionCountFlag + START_LOG_PAGE;
         If ((PageToRead > END_LOG_PAGE) Or (PageToRead > MissionCountFlag)) Then
         
         // !!!
         Begin
            { done }
            LastMissionCount := MissionCount;
            { Check for MissionCount miss-match to data (3.11B2) }
            { read the status page to get mission status }
            flag := ReadPage(STATUS_PAGE,@StatusBuf[0]);
            If (flag = TRECSUCCESS) Then
            Begin
               SetStatus('Read Status page: Success');
               { interpret the data in the status page }
               UpdateStatus;
               { now check if mission count changed }
               If (LastMissionCount <> MissionCount) Then
               Begin
                  { get number of seconds in current clock }
                  flag := (StatusBuf[$00] shr 4) * 10 +
                          (StatusBuf[$00] And $0F);
                  { if seconds are not recent new reading was done
                    before end page was read }
                  If (flag > 1) Then
                  Begin
                     SetStatus('Using new Mission Count');
                     LastMissionCount := MissionCount;
                  End;
               End;
            End;
            { interpret the log data }
            UpdateLog;
            { go to verify }
            TRECMode := TREC_VERIFY;
            FastScan := False;
            TRecTimer.Interval := SLOW_SCAN;
            { enable the re-read and export buttons }
            ReadButton.Enabled := True;
            ExportButton.Enabled := True;
            MenuExportToClip.Enabled := True;
            MenuStopMission.Enabled := True;
            If (OnGoingMission) Then
            Begin
               ForceButton.Enabled := False;
               ForceTempLabel.Visible := False;
            End
            Else
            Begin
               ForceButton.Enabled := True;
               ForceTempLabel.Visible := True;
            End;
            { check for auto export prompt }
            If (MenuAutoExport.Checked And DoAutoExport) Then
               ExportData(False);
         End;
      End
      Else If (flag = TRECNO_DEVICE) Then
         NoDevice(True)
      { other error }
      Else If ((flag < 0) And (flag <> TRECNO_SESSION)) Then
      Begin
         SetStatus('Read Log page: ' + IntToStr(PageToRead) + ' Error ' + IntToStr(ErrorType));
         { count consistent errors }
         If (ErrorType <> flag) Then
         Begin
            ErrorCnt := 0;
            ErrorType := flag;
         End
         Else
            Inc(ErrorCnt);

         { if long string of errors, then report }
         If (ErrorCnt > 10) Then
         Begin
            ErrorCnt := 0;
            MessageBeep(MB_OK);
            tstr := 'Error reading log page (' + IntToStr(ErrorType) + ')!';
            Application.MessageBox(StrPCopy(cstr,tstr),
                       AppName, mb_OK + mb_IconExclamation + mb_ApplModal);
         End;
      End;
   End
   { clear the memory }
   Else If (TRECMode = TREC_CLEAR_MEM) Then
   Begin
      SetStatus('Clear memory ');
      { clear the memory using timed access}
      flag := ClearMemory;
      If (flag = TRECSUCCESS) Then
      Begin
         SetStatus('Clear memory: Success');
         { now try to verify the clear memory }
         TRECMode := TREC_CLEAR_VERIFY;
      End
      Else If (flag = TRECNO_DEVICE) Then
         NoDevice(True)
      { other error }
      Else If ((flag < 0) And (flag <> TRECNO_SESSION)) Then
      Begin
         SetStatus('Clear memory: Error ' + IntToStr(ErrorType));
         { count consistent errors }
         If (ErrorType <> flag) Then
         Begin
            ErrorCnt := 0;
            ErrorType := flag;
         End
         Else
            Inc(ErrorCnt);

         { if long string of errors, then report }
         If (ErrorCnt > 10) Then
         Begin
            ErrorCnt := 0;
            MessageBeep(MB_OK);
            tstr := 'Error reading status page (' + IntToStr(ErrorType) + ')!';
            Application.MessageBox(StrPCopy(cstr,tstr),
                       AppName, mb_OK + mb_IconExclamation + mb_ApplModal);
         End;
      End;
   End
   { verify the clear the memory }
   Else If (TRECMode = TREC_CLEAR_VERIFY) Then
   Begin
      SetStatus('Verify clear memory ');
      { clear the memory using timed access }
      flag := ReadPage(STATUS_PAGE,@StatusBuf[0]);
      If (flag = TRECSUCCESS) Then
      Begin
         { check the clear memory bit }
         If ((StatusBuf[$14] And $40) = $40) Then
         Begin
            SetStatus('Verify clear memory: Success');
            { now try to write the mission }
            TRECMode := TREC_WRITE_MISSION;
            WriteMissionMode := WM_WRITE_TIME;
         End
         Else
         Begin
            SetStatus('ERROR, memory is not clear!');
            { go back and try again }
            TRECMode := TREC_CLEAR_MEM;
         End
      End
      Else If (flag = TRECNO_DEVICE) Then
         NoDevice(True)
      { other error }
      Else If ((flag < 0) And (flag <> TRECNO_SESSION)) Then
      Begin
         SetStatus('Clear memory: Error ' + IntToStr(ErrorType));
         { count consistent errors }
         If (ErrorType <> flag) Then
         Begin
            ErrorCnt := 0;
            ErrorType := flag;
         End
         Else
            Inc(ErrorCnt);

         { if long string of errors, then report }
         If (ErrorCnt > 10) Then
         Begin
            ErrorCnt := 0;
            MessageBeep(MB_OK);
            tstr := 'Error reading status page (' + IntToStr(ErrorType) + ')!';
            Application.MessageBox(StrPCopy(cstr,tstr),
                       AppName, mb_OK + mb_IconExclamation + mb_ApplModal);
         End;
      End;
   End
   { clear the memory }
   Else If (TRECMode = TREC_WRITE_MISSION) Then
   Begin
      SetStatus('Write the mission');
      { create the buffer to write }
      CreateWriteStatus;
      { clear the memory using timed access}
      flag := WriteMission;
      If (flag = TRECSUCCESS) Then
      Begin
         { write time,time alarm, temp thresholds }
         If (WriteMissionMode = WM_WRITE_TIME) Then
         Begin
            SetStatus('Time, time alarm, thresholds set');
            WriteMissionMode := WM_WRITE_CONTROL;
         End
         { write control, start delay }
         Else If (WriteMissionMode = WM_WRITE_CONTROL) Then
         Begin
            SetStatus('Control, start delay set');
            WriteMissionMode := WM_WRITE_SAMPLE;
         End
         { write the sample rate }
         Else If (WriteMissionMode = WM_WRITE_SAMPLE) Then
         Begin
            SetStatus('Sample rate set');
            { go to read the mission }
            TRECMode := TREC_CHECK_MISSION;
            { show the status of the new mission }
            MissionGroup.Visible := False;
            TempGroup.Visible := False;
            TimeGroup.Visible := False;
            DisableEvents := True;
            RecTab.PageIndex := 2;
            DisableEvents := False;
            { clear out any old data }
            ReadButton.Enabled := True;
            ExportButton.Enabled := False;
            MenuExportToClip.Enabled := False;
            LogRadio.Enabled := False;
            HistRadio.Enabled := False;
            LogList.Clear;
            HistList.Clear;
            AlarmList.Clear;
            LogBox.Visible := False;
            HistogramBox.Visible := False;
            AlarmBox.Visible := False;
         End;
      End
      Else If (flag = TRECNO_DEVICE) Then
         NoDevice(True)
      { other error }
      Else If ((flag < 0) And (flag <> TRECNO_SESSION)) Then
      Begin
         SetStatus('Write mission: Error ' + IntToStr(ErrorType));
         { count consistent errors }
         If (ErrorType <> flag) Then
         Begin
            ErrorCnt := 0;
            ErrorType := flag;
         End
         Else
            Inc(ErrorCnt);

         { if long string of errors, then report }
         If (ErrorCnt > 10) Then
         Begin
            ErrorCnt := 0;
            MessageBeep(MB_OK);
            tstr := 'Error writing status page (' + IntToStr(ErrorType) + '), on step (' +
                    IntToStr(WriteMissionMode) + ')';
            Application.MessageBox(StrPCopy(cstr,tstr),
                       AppName, mb_OK + mb_IconExclamation + mb_ApplModal);
         End;
      End;
   End
   { stop the current mission }
   Else If (TRECMode = TREC_STOP_MISSION) Then
   Begin
      SetStatus('Stop current mission ');
      { clear the memory using timed access }
      flag := StopMission;
      If (flag = TRECSUCCESS) Then
      Begin
         SetStatus('Stop current mission: Success ');
         { send to read the current state }
         TRECMode := TREC_READTIME;
      End
      Else If (flag = TRECNO_DEVICE) Then
         NoDevice(True)
      { other error }
      Else If ((flag < 0) And (flag <> TRECNO_SESSION)) Then
      Begin
         SetStatus('Stop mission: Error ' + IntToStr(ErrorType));
         { count consistent errors }
         If (ErrorType <> flag) Then
         Begin
            ErrorCnt := 0;
            ErrorType := flag;
         End
         Else
            Inc(ErrorCnt);

         { if long string of errors, then report }
         If (ErrorCnt > 10) Then
         Begin
            ErrorCnt := 0;
            MessageBeep(MB_OK);
            tstr := 'Error stopping mission (' + IntToStr(ErrorType) + ')!';
            Application.MessageBox(StrPCopy(cstr,tstr),
                       AppName, mb_OK + mb_IconExclamation + mb_ApplModal);
         End;
      End
   End
   { do a convesion (must not be a mission going) }
   Else If (TRECMode = TREC_DO_CONVERSION) Then
   Begin
      SetStatus('Send conversion command ');
      { clear the memory using timed access }
      flag := ForceConversion;
      If (flag = TRECSUCCESS) Then
      Begin
         SetStatus('Send conversion command: Success ');
         { send to read the current state }
         LastStatusTime := GetTickCount;
         TRECMode := TREC_VERIFY;
      End
      Else If (flag = TRECNO_DEVICE) Then
         NoDevice(True)
      { other error }
      Else If ((flag < 0) And (flag <> TRECNO_SESSION)) Then
      Begin
         SetStatus('Conversion Error ' + IntToStr(ErrorType));
         { count consistent errors }
         If (ErrorType <> flag) Then
         Begin
            ErrorCnt := 0;
            ErrorType := flag;
         End
         Else
            Inc(ErrorCnt);

         { if long string of errors, then report }
         If (ErrorCnt > 10) Then
         Begin
            ErrorCnt := 0;
            MessageBeep(MB_OK);
            tstr := 'Error sending conversion (' + IntToStr(ErrorType) + ')!';
            Application.MessageBox(StrPCopy(cstr,tstr),
                       AppName, mb_OK + mb_IconExclamation + mb_ApplModal);
         End;
      End
   End
   { verify the device is connected }
   Else If (TRECMode = TREC_VERIFY) Then
   Begin
      SetStatus('Verify');
      flag := VerifyDevice;
      If (flag = TRECSUCCESS) Then
      Begin
         NoDevice(False);
         SetStatus('Device Present');
      End
      Else If (flag = TRECNO_DEVICE) Then
      Begin
         NoDevice(True);
         SetStatus('Device NOT Present');
      End;
      { check if time to do a sample }
      If (((GetTickCount - LastStatusTime) + TRecTimer.Interval * 2) >= TIME_READ_INTERVAL) Then
         TRecMode := TREC_READTIME;
      { Keep track of size/position }
      GetSizePos;
   End;

   TRecTimer.Enabled := True;
end;


{----------------------------------------------------------------------------}
{ Set or clear the NoDevice message
}
Function TTRecForm.VerifyDevice: SmallInt;
Var
   rt,flag : SmallInt;
Begin
   {attempt to get a session }
   SHandle := TMExtendedStartSession(PortNum,PortType,nil);
   If (SHandle > 0) Then
   Begin
      Light(True); { Turn the light on }
      { set the rom }
      TMRom(SHandle,StateBuf,@ROM);
      { access and verify it is there }
      flag := TMStrongAccess(SHandle,StateBuf);
      If (flag = 1) Then
         rt := TRECSUCCESS
      Else
         rt := TRECNO_DEVICE;
      { close the opened session }
      TMEndSession(SHandle);
      Light(False);  { Turn the light off }
   End
   Else
      rt := TRECNO_SESSION;

   VerifyDevice := rt;
End;

{----------------------------------------------------------------------------}
{ Set or clear the NoDevice message
}
procedure TTRecForm.NoDevice(state : Boolean);
Begin
   If (state <> DeviceGone) Then
   Begin
      If (state) Then
      Begin
         TopPanel.Caption := 'No Device  ';
      End
      Else
      Begin
         TopPanel.Caption := '';
      End;
      FlashTime := GetTickCount + 400;
      DeviceGone := state;
   End;

   If ((DeviceGone) And (GetTickCount > FlashTime)) Then
   Begin
      { check for autoclose }
      If (AutoClose) Then
         { check to make sure device is really gone (3.10) }
         If (ReallyGone) Then
            { close }
            Application.Terminate;
      FlashTime := GetTickCount + 400;
      If (Length(TopPanel.Caption) > 0) Then
         TopPanel.Caption := ''
      Else
         TopPanel.Caption := 'No Device  ';
   End;
End;
{----------------------------------------------------------------------------}
{ Get the size and position of this device viewer if normal
}
Procedure TTRecForm.GetSizePos;
Begin
   { Keep track of size/position }
   If (WindowState <> wsMaximized) Then
   Begin
      LTop := Top;
      LLeft := Left;
   End;
End;

{----------------------------------------------------------------------------}
{ Change the light state
}
Procedure TTRecForm.Light(state : Boolean);
Begin
   If (state) Then
   Begin
      { turn ON the green lignt }
      GreenLight.Brush.Color := clLime;
      GreenLight.Refresh;
   End
   Else
      GreenLight.Brush.Color := clGray;
End;

{----------------------------------------------------------------------------}
{ Verify that a device is no longer connected to the MicroLan
}
Function TTRecForm.ReallyGone: Boolean;
Var
   rt : Boolean;
   Stamp : LongInt;
Begin
   {attempt to get a session }
   SHandle := TMExtendedStartSession(PortNum,PortType,nil);
   If (SHandle > 0) Then
   Begin
      Light(True); { Turn the light on }

      { loop to do multiple strong access }
      rt := True;
      Stamp := GetTickCount + 500;
      While (Stamp > GetTickCount) Do
      Begin
         If (TMStrongAccess(SHandle,StateBuf) = 1) Then
         Begin
            rt := False;
            Break;
         End;
      End;

      { close the opened session }
      TMEndSession(SHandle);
      Light(False);   { Turn the light off }
   End
   Else
      { play it safe and say the part is still here }
      rt := False;

   { set return value }
   ReallyGone := rt;
End;

{----------------------------------------------------------------------------}
{ kill this entity
}
procedure TTRecForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   { close }
   Application.Terminate;
end;

{----------------------------------------------------------------------------}
{ Free the TMEX Buffer when killing this entity
}
procedure TTRecForm.FormDestroy(Sender: TObject);
begin
   { free the TMEX buffer }
   If (GotBuf) Then
      FreeMem(StateBuf,REG_STATE_BUF);
end;

{----------------------------------------------------------------------------}
{ Set the status display with the provided string
}
Procedure TTRecForm.SetStatus(StatusString : String);
Begin
   { could save these ???}
   If (CompareStr(Status.Caption,' ' + StatusString) <> 0) Then
      Status.Caption := ' ' + StatusString;
End;

{----------------------------------------------------------------------------}
{ kill this entity
}
procedure TTRecForm.MenuExitClick(Sender: TObject);
begin
   { close }
   Application.Terminate;
end;

{----------------------------------------------------------------------------}
{ Next button click
}
procedure TTRecForm.NextButtonClick(Sender: TObject);
Var
   treal : Real;
begin
   { check if next page is finish page }
   If ((Wizard.PageIndex + 2) = Wizard.Pages.Count) Then
   Begin
      { set button enable states }
      NextButton.Enabled := False;
      FinishButton.Enabled := True;
      { create the finish statement }
      UpdateFinishStatement;
   End;

   { check if next page is time estimate (3.11) }
   If ((Wizard.PageIndex + 3) = Wizard.Pages.Count) Then
   Begin
      treal := ((SampleMinutes.ItemIndex + 1) * 2048.0) / 1440.0;
      RolloverDays.Caption := Format('%3.1f',[treal]) + ' Days';
   End;

   { go to the next page }
   Wizard.PageIndex := Wizard.PageIndex + 1;

   { check for ability to backup }
   If (Wizard.PageIndex > 0) Then
      BackButton.Enabled := True;

end;

{----------------------------------------------------------------------------}
{ Back button click
}
procedure TTRecForm.BackButtonClick(Sender: TObject);
begin
   { go to the previous page }
   Wizard.PageIndex := Wizard.PageIndex - 1;
   { went back so must be able to go foward also }
   NextButton.Enabled := True;
   FinishButton.Enabled := False;

   { check for ability to backup }
   If (Wizard.PageIndex = 0) Then
      BackButton.Enabled := False;
end;

{----------------------------------------------------------------------------}
{ Change alarm settings
}
procedure TTRecForm.AlarmTimeComboChange(Sender: TObject);
begin
   { set the visible state of the alarm options depending on alarm type }
   ShowTimeAlarm;
end;

{----------------------------------------------------------------------------}
{ Update display of time alarm
}
procedure TTRecForm.ShowTimeAlarm;
Begin
   { hide if not selected (none or every second) }
   If (AlarmTimeCombo.ItemIndex = 5) Or (AlarmTimeCombo.ItemIndex = 0) Then
   Begin
      HidePanel.Visible := False;
   End
   { visible depending on alarm option (weekly) }
   Else If (AlarmTimeCombo.ItemIndex = 1) Then
   Begin
      HidePanel.Visible := True;
      AlarmLabel.Visible := True;
      DayLabel.Visible := True;
      HourLabel.Visible := True;
      MinuteLabel.Visible := True;
      SecondLabel.Visible := True;
      AlarmDay.Visible := True;
      AlarmHour.Visible := True;
      AlarmMinute.Visible := True;
      AlarmSecond.Visible := True;
   End
   { visible depending on alarm option (daily) }
   Else If (AlarmTimeCombo.ItemIndex = 2) Then
   Begin
      HidePanel.Visible := True;
      AlarmLabel.Visible := True;
      DayLabel.Visible := False;
      HourLabel.Visible := True;
      MinuteLabel.Visible := True;
      SecondLabel.Visible := True;
      AlarmDay.Visible := False;
      AlarmHour.Visible := True;
      AlarmMinute.Visible := True;
      AlarmSecond.Visible := True;
   End
   { visible depending on alarm option (hourly) }
   Else If (AlarmTimeCombo.ItemIndex = 3) Then
   Begin
      HidePanel.Visible := True;
      AlarmLabel.Visible := True;
      DayLabel.Visible := False;
      HourLabel.Visible := False;
      MinuteLabel.Visible := True;
      SecondLabel.Visible := True;
      AlarmDay.Visible := False;
      AlarmHour.Visible := False;
      AlarmMinute.Visible := True;
      AlarmSecond.Visible := True;
   End
   { visible depending on alarm option (minutly) }
   Else If (AlarmTimeCombo.ItemIndex = 4) Then
   Begin
      HidePanel.Visible := True;
      AlarmLabel.Visible := True;
      DayLabel.Visible := False;
      HourLabel.Visible := False;
      MinuteLabel.Visible := False;
      SecondLabel.Visible := True;
      AlarmDay.Visible := False;
      AlarmHour.Visible := False;
      AlarmMinute.Visible := False;
      AlarmSecond.Visible := True;
   End;
End;

{----------------------------------------------------------------------------}
{ Change in length of delay
}
procedure TTRecForm.DelayDayChange(Sender: TObject);
begin
   DelayMinutes := DelayDay.ItemIndex * 1440 + DelayHour.ItemIndex * 60 + DelayMinute.ItemIndex;
   TotalMinutesLabel.Caption := IntToStr(DelayMinutes);
end;

{----------------------------------------------------------------------------}
{ Change in length of delay
}
procedure TTRecForm.CreateThresholds;
Var
   i,oldhigh,oldlow : LongInt;
   treal : Real;
begin
   { get the current index }
   oldhigh := 0;
   If (HighThreshold.ItemIndex >= 0) Then
      oldhigh := HighThreshold.ItemIndex;
   oldlow := 0;
   If (LowThreshold.ItemIndex >= 0) Then
      oldlow := LowThreshold.ItemIndex;
   { clear whatever it there }
   HighThreshold.Clear;
   LowThreshold.Clear;
   { loop to fill the combo boxes }
   For i := 0 to 255 Do { 3.12 }
   Begin
      treal := i * TempResolution + TempZero;
      If (MenuFahrenheit.Checked = True) Then
         treal := (treal * 9.0 / 5.0) + 32.0;
      HighThreshold.Items.Add(Format('%3.2f',[treal]));
      LowThreshold.Items.Add(Format('%3.2f',[treal]));
   End;
   { set back the item index }
   HighThreshold.ItemIndex := oldhigh;
   LowThreshold.ItemIndex := oldlow;
End;

{----------------------------------------------------------------------------}
{ set to fahrenheit
}
procedure TTRecForm.MenuFahrenheitClick(Sender: TObject);
begin
   MenuFahrenheit.Checked := Not MenuFahrenheit.Checked;
   MenuCelsius.Checked := Not MenuFahrenheit.Checked;
   ChangeTempScale;
end;

{----------------------------------------------------------------------------}
{ set to Celsius
}
procedure TTRecForm.MenuCelsiusClick(Sender: TObject);
begin
   MenuCelsius.Checked := Not MenuCelsius.Checked;
   MenuFahrenheit.Checked := Not MenuCelsius.Checked;
   ChangeTempScale;
end;

{----------------------------------------------------------------------------}
{ Change the temp scale
}
procedure TTRecForm.ChangeTempScale;
Begin
   If (MenuFahrenheit.Checked) Then
   Begin
      DegreeLabel.Caption := '(Fahrenheit)';
      CreateThresholds;
      If (LogBox.Visible) Then
         UpdateLog;
      If (HistogramBox.Visible) Then
         UpdateHistogram;
      If (AlarmBox.Visible) Then
         UpdateAlarms;
      UpdateStatus;
   End
   Else
   Begin
      DegreeLabel.Caption := '(Celsius)';
      CreateThresholds;
      If (LogBox.Visible) Then
         UpdateLog;
      If (HistogramBox.Visible) Then
         UpdateHistogram;
      If (AlarmBox.Visible) Then
         UpdateAlarms;
      UpdateStatus;
   End;
End;

{----------------------------------------------------------------------------}
{ Change in sample time
}
procedure TTRecForm.SampleMinutesChange(Sender: TObject);
Var
   treal : Real;
begin
   treal := ((SampleMinutes.ItemIndex + 1) * 2048.0) / 1440.0;
   RolloverDays.Caption := Format('%3.1f',[treal]) + ' Days';
end;

{----------------------------------------------------------------------------}
{ Take the data in StatusBuf and interpret it, update display
}
procedure TTRecForm.UpdateStatus;
Var
   tstr,tail : String;
   treal : Real;
   second,minute,hour,day,month,year,msec,i : Word;
   CurrentDT : TDateTime;   { 3.12 }
   is2K : Boolean;  { 3.12 }
Begin
   { mission status }
   If ((StatusBuf[$14] And $20) = $20) Then
   Begin
      MissionStatus.Caption := 'in progress';
      OnGoingMission := True;
   End
   Else
   Begin
      MissionStatus.Caption := 'ended';
      OnGoingMission := False;
   End;
   { roll-over enabled }
   If ((StatusBuf[$0E] And $08) = $08) Then
      RolloverEnableLabel.Caption := 'yes'
   Else
      RolloverEnableLabel.Caption := 'no';
   { real time clock register }
   CurrentDT := BCDTimeToString(@StatusBuf[$00],TRUE,(StatusBuf[$05] shr 7) = 1,tstr); { 3.12 }
   CurrentTimeLabel.Caption := tstr;
   TRecTimeLabel.Caption := tstr;

   { format the pc time the same }
   DecodeTime(Now,hour,minute,second,msec);
   DecodeDate(Now,year,month,day);
   PCTimeLabel.Caption := Format('%s  %.2d/%.2d/%.4d  %.2d:%.2d:%.2d ',
         [Days[DayOfWeek(Now)], month,day,year,hour,minute,second]);
   { real time clock alarm MODE and value }
   If ((StatusBuf[$09] And $40) = $40) Then
   Begin
      { 12 hour mode }
      If ((StatusBuf[$09] And $20) = $20) Then
         tstr := 'PM'
      Else
         tstr := 'AM';
   End
   Else
      { 24 hour mode }
      tstr := '';
   If ((StatusBuf[$07] And $80) <> $80) Then
   Begin
      { seconds }
      tstr := BCD(StatusBuf[$07] And $7F,1) + BCD(StatusBuf[$07],0) + tstr;
      If ((StatusBuf[$08] And $80) <> $80) Then
      Begin
         { minutes }
         tstr := BCD(StatusBuf[$08] And $7F,1) + BCD(StatusBuf[$08],0) + ':' + tstr;
         If ((StatusBuf[$09] And $80) <> $80) Then
         Begin
            { hours }
            If ((StatusBuf[$09] And $40) = $40) Then
               tstr := BCD(StatusBuf[$09] And $1F,1) + BCD(StatusBuf[$09],0) + ':' + tstr
            Else
               tstr := BCD(StatusBuf[$09] And $3F,1) + BCD(StatusBuf[$09],0) + ':' + tstr;
            If ((StatusBuf[$0A] And $80) <> $80) Then
            Begin
               { days }
               tstr := Days[StatusBuf[$0A] And $07] + ' ' + tstr;
               AlarmModeLabel.Caption := 'Alarm weekly';
               ClockAlarmMode := ALARM_WEEKLY;
            End
            Else
            Begin
               AlarmModeLabel.Caption := 'Alarm daily';
               ClockAlarmMode := ALARM_DAILY;
            End
         End
         Else
         Begin
            AlarmModeLabel.Caption := 'Alarm hourly';
            ClockAlarmMode := ALARM_HOURLY;
         End
      End
      Else
      Begin
         AlarmModeLabel.Caption := 'Alarm minutely';
         ClockAlarmMode := ALARM_MINUTELY;
      End
   End
   Else
   Begin
      AlarmModeLabel.Caption := 'Alarm every second';
      ClockAlarmMode := ALARM_SECOND;
   End;
   TimeAlarmSettingLabel.Caption := tstr;
   { mission count (3.12) }
   MissionCount := 0;
   For i := $1C downto $1A Do
   Begin
      MissionCount := MissionCount shl 8;
      MissionCount := MissionCount Or StatusBuf[i];
   End;
   MissionSamplesLabel.Caption := IntToStr(MissionCount);
   { device count (3.12) }
   DeviceCount := 0;
   For i := $1F downto $1D Do
   Begin
      DeviceCount := DeviceCount shl 8;
      DeviceCount := DeviceCount Or StatusBuf[i];
   End;
   DeviceCountLabel.Caption := IntToStr(DeviceCount);
   { sample rate }
   SampleRateLabel.Caption := IntToStr(StatusBuf[$0D]);
   SampleRate := StatusBuf[$0D];
   { 3.12 Check on the mission start century }
   { check if century bit set in mission start }
   if ((StatusBuf[$18] And $80) = $80) Then
   Begin
      is2K := TRUE;
   End
   Else If (OnGoingMission) Then
   Begin
      CurrentDT := CurrentDT - (EncodeTime(0,1,0,0) * SampleRate * MissionCount);
      DecodeDate(CurrentDT,year,month,day);
      is2K := (year >= 2000);
   End
   Else
   Begin
      { get decades of year }
      year := (Byte(StatusBuf[$19]) shr 4) * 10 + (Byte(StatusBuf[$19]) And $0F);
      is2K := (year < 70);
   End;
   { mission start time }
   MissionStartDT := BCDTimeToString(@StatusBuf[$15],FALSE,is2K,tstr); { 3.12 }
   MissionStartLabel.Caption := tstr;
   { roll over occured }
   If ((StatusBuf[$0E] And $08) = $08) Then
   Begin
      If (MissionCount > 2048) Then
         RolloverOccuredLabel.Caption := 'yes'
      Else
         RolloverOccuredLabel.Caption := 'no';
   End
   Else
      RolloverOccuredLabel.Caption := 'n/a';
   { mission start delay }
   MissionDelay := StatusBuf[$12] Or (StatusBuf[$13] shl 8);
   MissionDelayLabel.Caption := IntToStr(MissionDelay);
   { high trip }
   If (MenuShowFC.Checked) Then
   Begin
      If (MenuFahrenheit.Checked = True) Then
         tail := 'F'
      Else
         tail := 'C';
   End
   Else
      tail := '';
   treal := (StatusBuf[$0C] * TempResolution) + TempZero;
   If (MenuFahrenheit.Checked = True) Then
      treal := (treal * 9.0 / 5.0) + 32.0;
   HighThresholdLabel.Caption := Format('%3.1f',[treal]) + tail;
   HighTrip := treal;
   { low trip }
   treal := (StatusBuf[$0B] * TempResolution) + TempZero;
   If (MenuFahrenheit.Checked = True) Then
      treal := (treal * 9.0 / 5.0) + 32.0;
   LowThresholdLabel.Caption := Format('%3.1f',[treal]) + tail;
   LowTrip := treal;
   { Not OnGoingMission and SIP = 0 the show forced conversion result }
   If ((Not OnGoingMission) And ((StatusBuf[$14] And $10) <> $10) And  { (3.11B2) }
        DidConversion) Then
   Begin
      treal := (StatusBuf[$11] * TempResolution) + TempZero;
      If (MenuFahrenheit.Checked = True) Then
         treal := (treal * 9.0 / 5.0) + 32.0;
      ForceTempLabel.Caption := Format('%3.1f',[treal]) + tail;
   End;
   { temp alarm conditions }
   tstr := 'Conditional(';
   If ((StatusBuf[$0E] And $06) = $06) Then
      tstr := tstr + 'H,L'
   Else If ((StatusBuf[$0E] And $02) = $02) Then
      tstr := tstr + 'H'
   Else If ((StatusBuf[$0E] And $04) = $04) Then
      tstr := tstr + 'L'
   Else
      tstr := tstr + 'none';
   tstr := tstr + ')  Alarm(';
   If ((StatusBuf[$14] And $06) = $06) Then
      tstr := tstr + 'H,L'
   Else If ((StatusBuf[$14] And $02) = $02) Then
      tstr := tstr + 'H'
   Else If ((StatusBuf[$14] And $04) = $04) Then
      tstr := tstr + 'L'
   Else
      tstr := tstr + 'none';
   tstr := tstr + ')';
   TempAlarmLabel.Caption := tstr;
   { time alarm conditions }
   tstr := 'Conditional(';
   If ((StatusBuf[$0E] And $01) = $01) Then
      tstr := tstr + 'yes'
   Else
      tstr := tstr + 'no';
   tstr := tstr + ')  Alarm(';
   If ((StatusBuf[$14] And $01) = $01) Then
      tstr := tstr + 'yes)'
   Else
      tstr := tstr + 'no)';
   TimeAlarmLabel.Caption := tstr;
   { check if not visible }
   If (MissionGroup.Visible = False) Then
   Begin
      MissionGroup.Visible := True;
      TempGroup.Visible := True;
      TimeGroup.Visible := True;
   End;
End;

{----------------------------------------------------------------------------}
{  Convert the BCD time to a string.
}
Function TTRecForm.BCDTimeToString(Time : PChar; HaveSeconds, is2000 : Boolean; Var ReturnString : String): TDateTime;
Var
   OffSet : SmallInt;
   tstr,tail : String;
   tempDateTime : TDateTime;
   second,minute,hour,day,month,year : Word;
Begin
   { check if have a seconds Byte }
   tstr := ' ';
   { (3.11B2) }
   If (HaveSeconds) Then
   Begin
      OffSet := 0;
      { day of week }
      tstr := Days[Byte(Time[$03])] + '  ';
   End
   Else
      { offset for month,day,year only }
      OffSet := -2;
   { month }
   tstr := tstr + BCD(Byte(Time[Offset + $05]) And $7F,1) + BCD(Byte(Time[Offset + $05]),0) + '/';
   month := ((Byte(Time[Offset + $05]) And $7F) shr 4) * 10 + (Byte(Time[Offset + $05]) And $0F);
   { day }
   tstr := tstr + BCD(Byte(Time[Offset + $04]),1) + BCD(Byte(Time[Offset + $04]),0) + '/';
   day := (Byte(Time[Offset + $04]) shr 4) * 10 + (Byte(Time[Offset + $04]) And $0F);
   { year }
   If (is2000) Then  { 3.12 }
   Begin
      tstr := tstr + '20';
      year := 2000;
   End
   else
   Begin
      tstr := tstr + '19';
      year := 1900;
   End;
   tstr := tstr + BCD(Byte(Time[Offset + $06]),1) + BCD(Byte(Time[Offset + $06]),0) + '  ';
   year := year + (Byte(Time[Offset + $06]) shr 4) * 10 + (Byte(Time[Offset + $06]) And $0F);
   { check for offset change if no seconds for minute,hour }
   If (Not HaveSeconds) Then
      OffSet := -1;
   { hour }
   If ((Byte(Time[Offset + $02]) And $40) = $40) Then
   Begin
      { 12 hour mode }
      {???Time24Hour := False; }
      tstr := tstr + BCD(Byte(Time[Offset + $02]) And $1F,1) + BCD(Byte(Time[Offset + $02]),0) + ':';
      hour := ((Byte(Time[Offset + $02]) And $1F) shr 4) * 10 + (Byte(Time[Offset + $02]) And $0F);
      If ((Byte(Time[Offset + $02]) And $20) = $20) Then
         tail := 'PM'
      Else
         tail := 'AM';
   End
   Else
   Begin
      { 24 hour mode }
      {????Time24Hour := True; }
      tstr := tstr + BCD(Byte(Time[Offset + $02]) And $3F,1) + BCD(Byte(Time[Offset + $02]),0) + ':';
      hour := ((Byte(Time[Offset + $02]) And $3F) shr 4) * 10 + (Byte(Time[Offset + $02]) And $0F);
      tail := '';
   End;
   { minute }
   tstr := tstr + BCD(Byte(Time[Offset + $01]),1) + BCD(Byte(Time[Offset + $01]),0);
   minute := (Byte(Time[Offset + $01]) shr 4) * 10 + (Byte(Time[Offset + $01]) And $0F);
   { seconds }
   If (HaveSeconds) Then
   Begin
      tstr := tstr + ':' + BCD(Byte(Time[$00]),1) + BCD(Byte(Time[$00]),0) + tail;
      second := (Byte(Time[$00]) shr 4) * 10 + (Byte(Time[$00]) And $0F);
   End
   Else
      second := 0;
   ReturnString := tstr + ' ';

   { check for invalid time-date }
   If ((month = 0) Or (day = 0)) Then
      ReturnString := 'not started yet';

   { now convert to the pascal format }
   Try
      { check for sure-fire exceptions }
      If (month = 0) Then
         month := 1;
      If (day = 0) Then
         day := 1;
      tempDateTime := EncodeDate(year,month,day) +
                      EncodeTime(hour,minute,second,0);
   Except
      tempDateTime := StrToDateTime('01/01/70 01:00:00');
   End;

   { set the return }
   BCDTimeToString := tempDateTime;
End;

{----------------------------------------------------------------------------}
{ Convert a nibble of the provided byte from BCD to a char.  Position=0 is
  the least sig nibble and Position=1 is the ms nibble.
}
Function TTRecForm.BCD(BCDToConvert : Byte; Position : SmallInt): Char;
Begin
   If (Position = 0) Then
      BCD := Chr((BCDToConvert And $0F) + $30)
   Else
      BCD := Chr((BCDToConvert shr 4) + $30);
End;

{----------------------------------------------------------------------------}
{ Convert a number to a two digit BCD byte. Works up to 99 decimal.
}
Function TTRecForm.ToBCD(NumToConvert : SmallInt): Byte;
Var
   rtbyte : Byte;
Begin
   rtbyte := (NumToConvert - ((NumToConvert div 10) * 10)) And $0F;
   rtbyte := rtbyte Or ((NumToConvert div 10) shl 4);
   ToBCD := rtbyte;
End;


{----------------------------------------------------------------------------}
{ Create a finish statement that contains all of the mission options selected
}
procedure TTRecForm.UpdateFinishStatement;
Var
   tstr,indent : String;
   AddLine : Boolean;
Begin
   AddLine := False;
   { set the indent length }
   indent := '           ';
   { prepare the memo }
   FinishMemo.Clear;
   { set pc clock }
   FinishMemo.Lines.Add('Set device clock from PC clock:');
   If (SetTimeCheck.Checked) Then
      tstr := 'Yes'
   Else
      tstr := 'No';
   FinishMemo.Lines.Add(indent + tstr);
   If (AddLine) Then
      FinishMemo.Lines.Add('');
   { alarm times }
   FinishMemo.Lines.Add('Time Alarm mode:');
   FinishMemo.Lines.Add(indent + AlarmTimeCombo.Items[AlarmTimeCombo.ItemIndex]);
   If (AddLine) Then
      FinishMemo.Lines.Add('');
   If ((AlarmTimeCombo.ItemIndex <> 0) And (AlarmTimeCombo.ItemIndex <> 5)) Then
   Begin
      FinishMemo.Lines.Add('Time to Alarm:');
      tstr := indent;
      If (AlarmDay.Visible) Then
         tstr := tstr + AlarmDay.Items[AlarmDay.ItemIndex] + ',';
      If (AlarmHour.Visible) Then
         tstr := tstr + ' Hour ' + AlarmHour.Items[AlarmHour.ItemIndex];
      If (AlarmMinute.Visible) Then
         tstr := tstr + ' Minute ' + AlarmMinute.Items[AlarmMinute.ItemIndex];
      If (AlarmSecond.Visible) Then
         tstr := tstr + ' Second ' + AlarmSecond.Items[AlarmSecond.ItemIndex];
      If (ConditionalOnTimeCheck.Checked) Then
         tstr := tstr + ' (search)';
      FinishMemo.Lines.Add(tstr);
      If (AddLine) Then
         FinishMemo.Lines.Add('');
   End;
   { mission start delay }
   FinishMemo.Lines.Add('Mission Start Delay:');
   tstr := indent;
   If (DelayDay.ItemIndex <> 0) Then
         tstr := tstr + DelayDay.Items[DelayDay.ItemIndex] + ' Day(s) ';
   If (DelayHour.ItemIndex <> 0) Then
         tstr := tstr + DelayHour.Items[DelayHour.ItemIndex] + ' Hour(s) ';
   If (DelayMinute.ItemIndex <> 0) Then
         tstr := tstr + DelayMinute.Items[DelayMinute.ItemIndex] + ' Minute(s) ';
   If (DelayDay.ItemIndex = 0) And (DelayHour.ItemIndex = 0) And
      (DelayMinute.ItemIndex = 0) Then
      FinishMemo.Lines.Add(indent + '0 Minutes')
   Else
      FinishMemo.Lines.Add(tstr);
   If (AddLine) Then
      FinishMemo.Lines.Add('');
   { sample rate }
   FinishMemo.Lines.Add('Sample Rate:');
   FinishMemo.Lines.Add(indent + SampleMinutes.Items[SampleMinutes.ItemIndex] + ' Minute(s)');
   If (AddLine) Then
      FinishMemo.Lines.Add('');
   { Temperature Alarms }
   FinishMemo.Lines.Add('Temperature Alarms:');
   tstr := indent;
   tstr := tstr + 'High: ' + HighThreshold.Items[HighThreshold.ItemIndex];
   If (MenuShowFC.Checked) Then
   Begin
      If (MenuFahrenheit.Checked) Then
         tstr := tstr + 'F'
      Else
         tstr := tstr + 'C';
   End;
   If (ConditionalOnTempHighCheck.Checked) Then
      tstr := tstr + ' (search)';
   tstr := tstr + ' Low: ' + LowThreshold.Items[LowThreshold.ItemIndex];
   If (MenuShowFC.Checked) Then
   Begin
      If (MenuFahrenheit.Checked) Then
         tstr := tstr + 'F'
      Else
         tstr := tstr + 'C';
   End;
   If (ConditionalOnTempLowCheck.Checked) Then
      tstr := tstr + ' (search)';
   FinishMemo.Lines.Add(tstr);
   If (AddLine) Then
      FinishMemo.Lines.Add('');
   { roll-over }
   FinishMemo.Lines.Add('Roll-Over:');
   tstr := indent;
   If (RolloverCheck.Checked) Then
      tstr := tstr + 'Enabled'
   Else
      tstr := tstr + 'Disabled';
   FinishMemo.Lines.Add(tstr);
End;

{----------------------------------------------------------------------------}
{ Read a page and place results at DataPointer 'DataP'
}
Function TTRecForm.ReadPage(Page: SmallInt; DataP : PByte): SmallInt;
Var
   rt,flag : SmallInt;
Begin
   {attempt to get a session }
   SHandle := TMExtendedStartSession(PortNum,PortType,nil);
   If (SHandle > 0) Then
   Begin
      Light(True); { Turn the light on }

      { check if did setup }
      If (Not DidSetup) Then
      Begin
         TMSetup(SHandle);
         DidSetup := True;
      End;

      { set the rom }
      TMRom(SHandle,StateBuf,@ROM);

      { read the page }
      flag := TMExtendedReadPage(SHandle,StateBuf,Page,DataP,0);
      If (flag > 0) Then
      Begin
         rt := TRECSUCCESS;
      End
      { no device }
      Else
      Begin
         { check if device really there }
         If (TMStrongAccess(SHandle,StateBuf) <> 1) Then
            rt := TRECNO_DEVICE
         Else
            rt := flag;
      End;

      { close the opened session }
      TMEndSession(SHandle);
      Light(False);  { Turn the light off }
   End
   Else
      rt := TRECNO_SESSION;

   ReadPage := rt;
End;

{----------------------------------------------------------------------------}
{ Force a temperature read (only can click if no mission going)
}
procedure TTRecForm.ForceButtonClick(Sender: TObject);
begin
   If ((TRECMode = TREC_READTIME) Or (TRECMode = TREC_VERIFY)) Then
   Begin
      TRECMode := TREC_DO_CONVERSION;
      ForceTempLabel.Caption := '';
      ForceTempLabel.Visible := True;
      DidConversion := True;
   End;
end;

{----------------------------------------------------------------------------}
{ Main page change
}
procedure TTRecForm.RecTabChange(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
Var
   ChangeOK : Boolean;
begin
   ChangeOK := True;
   { check on permission to change tabs depending on state }
   If (Not DisableEvents) Then
   Begin
      { going to wizard }
      If (NewTab = TAB_WIZARD) Then
      Begin
         { disable the work timer while looking at messages }
         TRecTimer.Enabled := False;
         { check if reading data now }
         If ((TRECMode <> TREC_READTIME) And (TRECMode <> TREC_VERIFY)) Then
         Begin
            If (Application.MessageBox('Temperature Recorder data currently being downloaded.'+Chr($0D)+
                     'Abandon the download to begin a new mission?',AppName, mb_OKCancel +
                      mb_IconExclamation + mb_ApplModal) = IDOK) Then
            Begin
               { disable options not available while downloading data }
               ReadButton.Enabled := True;
               ExportButton.Enabled := False;
               MenuExportToClip.Enabled := False;
               LogRadio.Enabled := False;
               HistRadio.Enabled := False;
               LogList.Clear;
               HistList.Clear;
               AlarmList.Clear;
               LogBox.Visible := False;
               HistogramBox.Visible := False;
               AlarmBox.Visible := False;
               { slow scan on verify }
               TRECMode := TREC_VERIFY;
               FastScan := False;
               TRecTimer.Interval := SLOW_SCAN;
            End
            Else
               ChangeOK := False;
         End;
         { start the wizard at the begining }
         Wizard.PageIndex := 0;
         NextButton.Enabled := True;
         BackButton.Enabled := False;
         FinishButton.Enabled := False;

         { re-enable the work timer }
         TRecTimer.Enabled := True;
      End
      { TAB_RESULT or TAB_STATUS }
      Else
      Begin
         { if writing mission stop and don't allow }
         If ((TRECMode = TREC_CLEAR_MEM) Or (TRECMode = TREC_CLEAR_VERIFY) Or
             (TRECMode = TREC_WRITE_MISSION)) Then
         Begin
            { disable the work timer while looking at messages }
            TRecTimer.Enabled := False;
            If (Application.MessageBox('Temperature Recorder mission currently being written.'+Chr($0D)+
                     'Abandon the new mission?',AppName, mb_OKCancel +
                      mb_IconExclamation + mb_ApplModal) = IDOK) Then
            Begin
               { go to read the mission }
               TRECMode := TREC_CHECK_MISSION;
               { show the status of the stopped mission }
               MissionGroup.Visible := False;
               TempGroup.Visible := False;
               TimeGroup.Visible := False;
               { clear out any old data }
               ReadButton.Enabled := True;
               ExportButton.Enabled := False;
               MenuExportToClip.Enabled := False;
               LogRadio.Enabled := False;
               HistRadio.Enabled := False;
               LogList.Clear;
               HistList.Clear;
               AlarmList.Clear;
               LogBox.Visible := False;
               HistogramBox.Visible := False;
               AlarmBox.Visible := False;
            End
            Else
               ChangeOK := False;
            { re-enable the work timer }
            TRecTimer.Enabled := True;
         End;
      End;
   End;
   AllowChange := ChangeOK;
end;

{----------------------------------------------------------------------------}
{ Graph log data
}
procedure TTRecForm.GraphLogButtonClick(Sender: TObject);
Var
   ChartForm: TChartForm;
   i,cnt,num,cpos : LongInt;
   HLabels: array[0..4] of String;
   tail,ttitle : String;
   second,minute,hour,day,month,year,msec : Word;
   tempDateTime : TDateTime;
   loops,overlap,entries : LongInt;
   interval : Double;
   MaxChartData, MinChartData : Real;
begin
   num := 0;
   { check if there is anything to graph }
   If (LogList.Items.Count <= 1) Then
   Begin
      Application.MessageBox('There is not enough data to graph!',
                       AppName, mb_OK + mb_IconExclamation + mb_ApplModal);
      Exit;
   End;

   { create the chart }
   ChartForm := TChartForm.Create(Self);

   { calculate the horizontal labels }
   If (LastMissionCount > 2048) Then
      cnt := 2048
   Else
      cnt := LastMissionCount;
   For i := 0 to 4 Do
   Begin
      If (i = 0) Then
         num := 0
      Else If (cnt > 10) Then
         num := i * (cnt div 4) - 1
      Else If (cnt <= 10) Then
      Begin
         num := LogList.Items.Count - 1;
      End;

      cpos := Pos(Delimiter,LogList.Items[num]);
      HLabels[i] := Copy(LogList.Items[num],1,cpos - 1);
      {$IFDEF WIN32}
      HLabels[i] := Trim(HLabels[i]);
      {$ENDIF}

      If (cnt <= 10) And (i <> 4) And (i <> 0) Then
         HLabels[i] := '';
   End;

   If (MenuShowFC.Checked) Then
   Begin
      If (MenuFahrenheit.Checked = True) Then
         tail := 'F'
      Else
         tail := 'C';
   End
   Else
      tail := '';

   { create a title with the time range }
   loops := 0;
   overlap := 2048;
   entries := LastMissionCount;
   If (((StatusBuf[$0E] And $08) = $08) And (LastMissionCount > 2048)) Then
   Begin
      loops := LastMissionCount div 2048;
      overlap := LastMissionCount mod 2048;
   End;
   If (entries > 2048) Then
      entries := 2048;
   interval := EncodeTime(0,1,0,0) * SampleRate;
   { start of log }
   tempDateTime := MissionStartDT + loops * (interval * 2048) -
                   interval * (2048 - overlap) ;
   DecodeTime(tempDateTime,hour,minute,second,msec);
   DecodeDate(tempDateTime,year,month,day);
   ttitle := Format(' %.2d/%.2d/%.4d  %.2d:%.2d ',
                 [month,day,year,hour,minute]) + ' to ';
   { end of log }
   tempDateTime := tempDateTime + interval * entries;
   DecodeTime(tempDateTime,hour,minute,second,msec);
   DecodeDate(tempDateTime,year,month,day);
   ttitle := ttitle + Format(' %.2d/%.2d/%.4d  %.2d:%.2d ',
                 [month,day,year,hour,minute]);
   { V3.20 Max and Min ChartData }
   If (MenuFahrenheit.Checked = True) Then
   Begin
      MaxChartData := 212.0;
      MinChartData := -40.0;
   End
   Else
   Begin
      MaxChartData := 100.0;
      MinChartData := -40.0;
   End;
   { V3.20 }
   ChartForm.CheckBoxAutoScale.Checked := True; // Turn Autoscale on
   ChartForm.CheckBoxAutoScale.Visible := False; // Make Autoscale invisible
   ChartForm.LineChart(LogData,cnt,HLabels,'Log',ttitle,LogRadio.Items[LogRadio.ItemIndex],
                       'Temp',tail, HighTrip, LowTrip, MaxChartData, MinChartData);
   ChartForm.Show;
end;

{----------------------------------------------------------------------------}
{ Graph histogram data
}
procedure TTRecForm.GraphHistButtonClick(Sender: TObject);
Var
   ChartForm: TChartForm;
   i,num,cpos,topos,hbin,lbin : LongInt;
   HLabels: array[0..4] of String;
   tstr,ttitle : String;
   tstart,tend : Real;
   second,minute,hour,day,month,year,msec : Word;
   tempDateTime : TDateTime;
   Count : LongInt;
begin
   { create the chart }
   ChartForm := TChartForm.Create(Self);
   ChartForm.CheckBoxAutoScale.Checked := True;
   ChartForm.CheckBoxAutoScale.Visible := False;

   { calculate the horizontal labels }
   For i := 0 to 4 Do
   Begin
      If (i = 0) Then
         num := 0
      Else
         num := 16 * i - 1;  
      cpos := Pos(',',HistList.Items[num]);
      topos := Pos('to',HistList.Items[num]);
      If (topos > 0) Then
         HLabels[i] := Copy(HistList.Items[num],1,topos - 1)
      Else
         HLabels[i] := Copy(HistList.Items[num],1,cpos - 1);
      {$IFDEF WIN32}
      HLabels[i] := Trim(HLabels[i]);
      {$ENDIF}
   End;

   { calculate the bin numbers where the trips reside }
   hbin := 63;
   lbin := 0;
   For i := 0 to 63 Do  { 3.12 }
   Begin
      { start/end temperature }
      tstart := (i * TempResolution * 4) + TempZero;
      tend := (i * TempResolution * 4) + TempZero + 3 * TempResolution;
      If (MenuFahrenheit.Checked = True) Then
      Begin
         tstart := (tstart * 9.0 / 5.0) + 32.0;
         tend := (tend * 9.0 / 5.0) + 32.0;
      End;
      { check if high or low }
      If (tstart <= HighTrip) And (tend >= HighTrip) Then
         hbin := i;
      If (tstart <= LowTrip) And (tend >= LowTrip) Then
         lbin := i;
   End;

   { create a title with the time range }
   DecodeTime(MissionStartDT,hour,minute,second,msec);
   DecodeDate(MissionStartDT,year,month,day);
   ttitle := Format(' %.2d/%.2d/%.4d  %.2d:%.2d ',
                 [month,day,year,hour,minute]) + ' to ';
   If (LastMissionCount > 0) Then
      Count := LastMissionCount
   Else
      Count := MissionCount;
   tempDateTime := MissionStartDT +
                   Count * (EncodeTime(0,1,0,0) * SampleRate);
   DecodeTime(tempDateTime,hour,minute,second,msec);
   DecodeDate(tempDateTime,year,month,day);
   ttitle := ttitle + Format(' %.2d/%.2d/%.4d  %.2d:%.2d ',
                 [month,day,year,hour,minute]);
   tstr := Copy(HistSyntax.Caption,1,Pos(',',HistSyntax.Caption) - 1);
   ChartForm.BarChart(HistData,HLabels,'Histogram',ttitle,tstr,'Count',hbin,lbin);
   ChartForm.Show;
end;

{----------------------------------------------------------------------------}
{ Take the data in TempLog and interpret it, update display
}
procedure TTRecForm.UpdateLog;
Var
   tstr,tail : String;
   treal : Real;
   i,loops,overlap,insert,entries : LongInt;
   second,minute,hour,day,month,year,msec : Word;
   tempDateTime : TDateTime;
   tempMinute : LongInt;
   interval, tdble : Double;
   tempcheck : Real;        // Check for "out of range" V3.20 Release
Begin
   { check for roll over }
   tempMinute := 0;
   loops := 0;
   overlap := 2048;
   insert := 0;
   entries := LastMissionCount; { 3.12B3 removed 'And $FFFF' }
   If (((StatusBuf[$0E] And $08) = $08) And (LastMissionCount > 2048)) Then
   Begin
      loops := LastMissionCount div 2048;
      overlap := LastMissionCount mod 2048;
   End;
   If (entries > 2048) Then
      entries := 2048;
   { calculate the sample interval }
   tdble := EncodeTime(0,1,0,0);
   interval := tdble * SampleRate;
   { start at the mission start date/time }
   tempDateTime := MissionStartDT;
   { add the number of loops }
   tempDateTime := tempDateTime + loops * (interval * 2048.0);
   { check if only minute offset }
   If (LogRadio.ItemIndex = 1) Then
      tempMinute := loops * (SampleRate * 2048);
   { check for degree type }
   If (MenuShowFC.Checked) Then
   Begin
      If (MenuFahrenheit.Checked = True) Then
         tail := 'F'
      Else
         tail := 'C';
   End
   Else
      tail := '';
   { loop to create entries }
   LogList.Clear;
   For i := 0 to entries - 1 Do
   Begin
      { check if only minute offset }
      If (LogRadio.ItemIndex = 1) Then
      Begin
         { number of minutes for this reading from start }
         tstr := IntToStr(tempMinute) + Delimiter;
         { add interval for the next entry }
         tempMinute :=  tempMinute + SampleRate;
      End
      Else
      Begin
         { get the current time }
         DecodeTime(tempDateTime,hour,minute,second,msec);
         DecodeDate(tempDateTime,year,month,day);
         { check for floating point bug in 16-bit (3.11) }
         If ((second <> 0) Or (msec <> 0)) Then
         Begin
            { round back up to nearist minute }
            tempDateTime := Round(tempDateTime * 1440.0) / 1440.0;
            { get the current time }
            DecodeTime(tempDateTime,hour,minute,second,msec);
            DecodeDate(tempDateTime,year,month,day);
         End;

         { time }
         tstr := Format(' %.2d/%.2d/%.4d  %.2d:%.2d ',
                 [month,day,year,hour,minute]) + Delimiter;

         { add interval for the next entry }
         tempDateTime := tempDateTime + interval;
      End;
      { temperature }
      treal := (TempLog[i] * TempResolution) + TempZero;

      { Check for temperature "out of range" V3.20 Release }
      tempcheck := Round(treal);
      if ((tempcheck > TempRangeHigh) or (tempcheck < TempRangeLow)) Then
      Begin
         MemoWarning.Visible := True;
      End;

      If (MenuFahrenheit.Checked = True) Then
         treal := (treal * 9.0 / 5.0) + 32.0;
      tstr := tstr + Format('%3.1f',[treal]) + tail;
      { record the log data (compensate for loop) }
      If (i < overlap) Then
         { save the logged data (compensate for loop) }
         LogData[i + 2048 - overlap] := treal
      Else
         { save the logged data (compensate for loop) }
         LogData[i - overlap] := treal;
      { add to list }
      LogList.Items.Insert(insert,tstr);
      { check for end of loop overlap }
      If (i = (overlap - 1)) Then
      Begin
         If (LogRadio.ItemIndex = 1) Then
            tempMinute := tempMinute - (SampleRate * 2048)
         Else
            tempDateTime := tempDateTime - (interval * 2048);
         insert := 0;
      End
      { update where to insert }
      Else
      Begin
         If (i < overlap) Then
         Begin
            { insert at end }
            insert := LogList.Items.Count;
         End
         Else
         Begin
            { insert at the top of the overlap }
            insert := LogList.Items.Count - overlap;
         End;
      End;
   End;
   { make sure visible }
   If (Not LogBox.Visible) Then
      LogBox.Visible := True;
   { check if posting options are visible }
   If (Not LogRadio.Enabled) Then
   Begin
      LogRadio.Enabled := True;
   End;
End;

{----------------------------------------------------------------------------}
{ Update the alarms from the data in Alarms
}
procedure TTRecForm.UpdateAlarms;
Var
   tstr : String;
   addr : LongInt;
   tempCount,tics : LongInt;
   tempDateTime : TDateTime;
   interval, tdble : Double;
   second,minute,hour,day,month,year,msec : Word;
Begin
   { calculate the sample interval }
   tdble := EncodeTime(0,1,0,0);
   interval := tdble * SampleRate;

   { loop through all of the alarms }
   AlarmList.Clear;
   addr := 0;
   While addr < 96 do
   Begin
      { check for an alarm entry }
      If (TempAlarms[addr + 3] <> 0) Then
      Begin
         { extract the count stamp (adjust -1) }
         tempCount := TempAlarms[addr] Or (TempAlarms[addr+1] shl 8) Or (TempAlarms[addr+2] shl 16);
         Dec(TempCount);
         { extract the tics count (adjust -1) }
         tics := TempAlarms[addr + 3];
         Dec(tics);
          { check if high or low }
         If (addr < 48) Then
            tstr := 'LOW  '
         Else
            tstr := 'HIGH ';

         { calculate the date or offset }
         If (LogRadio.ItemIndex = 1) Then
         Begin
            tstr := tstr + Delimiter + IntToStr(tempCount * SampleRate) + ' - ' +  
                    IntToStr((tempCount + tics) * SampleRate);
         End
         Else
         Begin
            { start at the start time plus start delay }
            tempDateTime := MissionStartDT + tempCount * interval;
            { start alarm time }
            DecodeTime(tempDateTime,hour,minute,second,msec);
            DecodeDate(tempDateTime,year,month,day);
            tstr := tstr + Delimiter + 'start:' + Format(' %.2d/%.2d/%.4d  %.2d:%.2d ',
                         [month,day,year,hour,minute]);
            AlarmList.Items.Add(tstr);
            tstr := '            end: ';
            { increment the amount of time }
            tempDateTime := tempDateTime + tics * interval;
            { end alarm time }
            DecodeTime(tempDateTime,hour,minute,second,msec);
            DecodeDate(tempDateTime,year,month,day);
            tstr := tstr + Format(' %.2d/%.2d/%.4d  %.2d:%.2d ',
                         [month,day,year,hour,minute]);
         End;
         AlarmList.Items.Add(tstr);
      End;
      addr := addr + 4;
   End;

   { check for no alarms }
   If (AlarmList.Items.Count = 0) Then
     AlarmList.Items.Add('none');

   { check if alarm box is visible }
   If (Not AlarmBox.Visible) Then
      AlarmBox.Visible := True;
End;


{----------------------------------------------------------------------------}
{ Update the histogram from the data in Histogram
}
procedure TTRecForm.UpdateHistogram;
Var
   tstr,tail : String;
   treal : Real;
   addr : LongInt;
Begin
   { check for degree type }
   If (MenuShowFC.Checked) Then
   Begin
      If (MenuFahrenheit.Checked = True) Then
         tail := 'F'
      Else
         tail := 'C';
   End
   Else
      tail := '';
   { loop to get all of the bins }
   HistList.Clear;
   addr := 0;
   For addr := 0 to 63 Do
   Begin
      { get the counter (3.12) }
      HistData[addr] := Histogram[addr * 2] Or (Histogram[addr * 2 + 1] shl 8) And $FFFF;
      { calculate the temperature for this bin }
      If ((HistRadio.ItemIndex = 0) Or (HistRadio.ItemIndex = 1)) Then
      Begin
         { start temperature }
         treal := addr * TempResolution * 4 + TempZero;
         If (MenuFahrenheit.Checked = True) Then
            treal := (treal * 9.0 / 5.0) + 32.0;
         tstr := Format('%3.2f',[treal]) + tail ;
      End;
      { end temperature }
      If (HistRadio.ItemIndex = 0) then
      Begin
         treal := addr * TempResolution * 4 + TempZero + 3 * TempResolution;
         If (MenuFahrenheit.Checked = True) Then
            treal := (treal * 9.0 / 5.0) + 32.0;
         tstr := tstr + ' to ' + Format('%3.2f',[treal]) + tail;
      End;
      { bin number }
      If (HistRadio.ItemIndex = 2) Then
         tstr := IntToStr(addr);
      tstr := tstr + Delimiter + IntToStr(HistData[addr]);
      { add to hist }
      HistList.Items.Add(tstr);
   End;
   { check if hist box is visible }
   If (Not HistogramBox.Visible) Then
   Begin
      HistogramBox.Visible := True;
      HistRadio.Enabled := True;
   End;
End;

{----------------------------------------------------------------------------}
{ Select radio Log display options
}
procedure TTRecForm.LogRadioClick(Sender: TObject);
begin
   If (Not DisableEvents) Then  { (3.11B2) }
   Begin
      If (LogRadio.ItemIndex = 0) Then
         LogSyntax.Caption := 'Time/Date ' + Delimiter + 'Temperature'
      Else
         LogSyntax.Caption := 'Minute Offset ' + Delimiter + 'Temperature';
      UpdateLog;
      UpdateAlarms;
   End;
end;

{----------------------------------------------------------------------------}
{ Select radio histogram display options
}
procedure TTRecForm.HistRadioClick(Sender: TObject);
begin
   If (Not DisableEvents) Then  { (3.11B2) }
   Begin
      If (HistRadio.ItemIndex = 0) Then
         HistSyntax.Caption := 'Temp Range ' + Delimiter + 'Count'
      Else If (HistRadio.ItemIndex = 1) Then
         HistSyntax.Caption := 'Start Temp ' + Delimiter + 'Count'
      Else
         HistSyntax.Caption := 'Bin Number ' + Delimiter + 'Count';
      UpdateHistogram;
   End;
end;

{----------------------------------------------------------------------------}
{ Read data again
}
procedure TTRecForm.ReadButtonClick(Sender: TObject);
begin
   { disable options not available while downloading data }
   ReadButton.Enabled := False;
   ExportButton.Enabled := False;
   MenuExportToClip.Enabled := False;
   LogRadio.Enabled := False;
   HistRadio.Enabled := False;
   LogList.Clear;
   HistList.Clear;
   AlarmList.Clear;
   LogBox.Visible := False;
   HistogramBox.Visible := False;
   AlarmBox.Visible := False;
   ForceButton.Enabled := False;
   ForceTempLabel.Visible := False;
   { step up the scan rate and start reading the data again }
   PageToRead := START_ALARMS_PAGE;
   TRECMode := TREC_READ_ALARM;
   FastScan := True;
   TRecTimer.Interval := FAST_SCAN;
   { mark when downloaded (3.11) }
   DownloadTimeDate := Now;
end;


{----------------------------------------------------------------------------}
{ Finish button click, start a mission
}
procedure TTRecForm.FinishButtonClick(Sender: TObject);
Var
   finish : Boolean;
begin
   finish := True;
   { check if mission is currently going on }
   If (OnGoingMission) Then
   Begin
      MessageBeep(MB_OK);
      If (Application.MessageBox('WARNING, a mission is currently running.'+Chr($0D)+
          'Erase this mission and start a new one?',AppName, mb_OKCancel +
          mb_IconExclamation + mb_ApplModal) = IDCANCEL) Then
         finish := False;
   End;
   { check if going to finish this }
   If (finish) Then
   Begin
      { disable the buttons while we try to write }
      NextButton.Enabled := False;
      BackButton.Enabled := False;
      FinishButton.Enabled := False;
      { set to write }
      TRECMode := TREC_CLEAR_MEM;
      FastScan := True;
      TRecTimer.Interval := FAST_SCAN;
      DoAutoExport := False;
   End;
end;

{----------------------------------------------------------------------------}
{ Create the write status buffer
}
procedure TTRecForm.CreateWriteStatus;
Var
   i,cnt : SmallInt;
   second,minute,hour,day,month,year,msec : Word;
   tempDateTime : TDateTime;
Begin
   { zero the write buffer }
   For i := 0 to 32 Do
      WriteStatusBuf[i] := 0;
   { start the count }
   cnt := 0;
   { set real-time clock }
   If (SetTimeCheck.Checked) Then
   Begin
      { get the current time }
      { add a second to accomododate the write time }
      tempDateTime := Now + EncodeTime(0,0,1,0);
      DecodeTime(tempDateTime,hour,minute,second,msec);
      DecodeDate(tempDateTime,year,month,day);
      { second }
      WriteStatusBuf[cnt] := ToBCD(second);
      Inc(cnt);
      { minute }
      WriteStatusBuf[cnt] := ToBCD(minute);
      Inc(cnt);
      { hour }
      WriteStatusBuf[cnt] := ToBCD(hour);
      {?????? assume 24 hour currently }
      Inc(cnt);
      { day of week }
      WriteStatusBuf[cnt] := ToBCD(DayOfWeek(tempDateTime));
      Inc(cnt);
      { date }
      WriteStatusBuf[cnt] := ToBCD(day);
      Inc(cnt);
      { month }
      WriteStatusBuf[cnt] := ToBCD(month);
      { check on centurary bit }
      If (year >= 2000) Then
         WriteStatusBuf[cnt] := WriteStatusBuf[cnt] Or $80;
      Inc(cnt);
      { year }
      year := year - ((year div 100) * 100);
      WriteStatusBuf[cnt] := ToBCD(year);
      Inc(cnt);
   End
   Else
      { start past the real time clock }
      cnt := 7;

   { alarm times }
   If (AlarmTimeCombo.ItemIndex <> 0) Then
   Begin
      { second }
      If (AlarmSecond.Visible) Then
         WriteStatusBuf[cnt] := ToBCD(AlarmSecond.ItemIndex)
      Else
         WriteStatusBuf[cnt] := $80;
      Inc(cnt);
      { minute }
      If (AlarmMinute.Visible) Then
         WriteStatusBuf[cnt] := ToBCD(AlarmMinute.ItemIndex)
      Else
         WriteStatusBuf[cnt] := $80;
      Inc(cnt);
      { hour }
      {?????? currently fixed at 24 hour mode }
      If (AlarmHour.Visible) Then
         WriteStatusBuf[cnt] := ToBCD(AlarmHour.ItemIndex)
      Else
         WriteStatusBuf[cnt] := $80;
      Inc(cnt);
      { day }
      If (AlarmDay.Visible) Then
         WriteStatusBuf[cnt] := ToBCD(AlarmDay.ItemIndex + 1)
      Else
         WriteStatusBuf[cnt] := $80;
      Inc(cnt);
   End
   Else
   Begin
      { don't really want so set to once a week, Sunday at midnight }
      WriteStatusBuf[cnt] := 0;  { second }
      Inc(cnt);
      WriteStatusBuf[cnt] := 0;  { minute }
      Inc(cnt);
      WriteStatusBuf[cnt] := 0;  { hour }
      Inc(cnt);
      WriteStatusBuf[cnt] := 1; { sunday }
      Inc(cnt);
   End;
   { Temperature Alarms }
   { low }
   WriteStatusBuf[cnt] := LowThreshold.ItemIndex;
   Inc(cnt);
   { high }
   WriteStatusBuf[cnt] := HighThreshold.ItemIndex;
   Inc(cnt);
   { sample rate }
   WriteStatusBuf[cnt] := SampleMinutes.ItemIndex + 1;
   Inc(cnt);
   { control }
   WriteStatusBuf[cnt] := 0;
   { roll-over }
   If (RolloverCheck.Checked) Then
      WriteStatusBuf[cnt] := WriteStatusBuf[cnt] Or $08;
   { conditional search on time alarm }
   If (ConditionalOnTimeCheck.Checked) Then
      WriteStatusBuf[cnt] := WriteStatusBuf[cnt] Or $01;
   { conditional search on low threshold }
   If (ConditionalOnTempLowCheck.Checked) Then
      WriteStatusBuf[cnt] := WriteStatusBuf[cnt] Or $04;
   { conditional search on high threshold }
   If (ConditionalOnTempHighCheck.Checked) Then
      WriteStatusBuf[cnt] := WriteStatusBuf[cnt] Or $02;
   Inc(cnt);
   { skip temperature read out, two zeros }
   cnt := cnt + 3;
   { mission start delay }
   WriteStatusBuf[cnt] := DelayMinutes And $FF;
   Inc(cnt);
   WriteStatusBuf[cnt] := (DelayMinutes shr 8) And $FF;
   Inc(cnt);
   { clear status 3.11B4 }
   WriteStatusBuf[cnt] := 0;
End;

{----------------------------------------------------------------------------}
{ Clear the memory using timed access
}
Function TTRecForm.ClearMemory: SmallInt;
Var
   rt,flag,BufCnt : SmallInt;
   Buf : array[0..50] of Byte;      { array of page data }
   {$IFNDEF WIN32}
   stamp: LongInt;
   {$ENDIF}
Begin
   rt := TRECNO_DEVICE;
   {attempt to get a session }
   SHandle := TMExtendedStartSession(PortNum,PortType,nil);
   If (SHandle > 0) Then
   Begin
      Light(True); { Turn the light on }

      { select the device }
      flag := TMAccess(SHandle,StateBuf);
      If (flag = 1) Then
      Begin
         { build a packet to write scratchpad }
         BufCnt := 0;
         { write scratchpad }
         Buf[BufCnt] := $0F;
         Inc(BufCnt);
         { address }
         Buf[BufCnt] := $0E;
         Inc(BufCnt);
         Buf[BufCnt] := $02;
         Inc(BufCnt);
         { data }
         Buf[BufCnt] := $40;
         Inc(BufCnt);
         { send the block }
         flag := TMBlockStream(SHandle, @Buf[0], BufCnt);
         { check results of block }
         If (flag = BufCnt) Then
         Begin
            { select the device }
            flag := TMAccess(SHandle,StateBuf);
            If (flag = 1) Then
            Begin
               { build a packet to copy scratchpad }
               BufCnt := 0;
               { copy scratchpad }
               Buf[BufCnt] := $55;
               Inc(BufCnt);
               { address }
               Buf[BufCnt] := $0E;
               Inc(BufCnt);
               Buf[BufCnt] := $02;
               Inc(BufCnt);
               { offset }
               Buf[BufCnt] := $0E;
               Inc(BufCnt);
               { copy verification }
               Buf[BufCnt] := $FF;
               Inc(BufCnt);
               { send the block }
               flag := TMBlockStream(SHandle, @Buf[0], BufCnt);
               { check results of block }
               If (flag = BufCnt) Then
               Begin
                  { check the verification byte }
                  If (((Buf[BufCnt - 1] And $F0) = $50) Or
                      ((Buf[BufCnt - 1] And $F0) = $A0)) Then
                  Begin
                     { select the device }
                     flag := TMAccess(SHandle,StateBuf);
                     If (flag = 1) Then
                     Begin
                        { send the clear memory command }
                        If (TMTouchByte(SHandle,$3C) = $3C) Then
                           rt := TRECSUCCESS;
                        {$IFDEF WIN32}
                        Sleep(3);
                        {$ELSE}
                        stamp := GetTickCount + 110;
                        While (stamp > GetTickCount) Do Application.ProcessMessages;
                        {$ENDIF}
                        TMTouchReset(SHandle);
                     End;
                  End;
               End;
            End;
         End;
      End;
      { close the opened session }
      TMEndSession(SHandle);
      Light(False);  { Turn the light off }
   End
   Else
      rt := TRECNO_SESSION;

   ClearMemory := rt;
End;

{----------------------------------------------------------------------------}
{ write the new mission
}
Function TTRecForm.WriteMission: SmallInt;
Var
   flag,rt,offset,addr,len : SmallInt;
Begin
   {attempt to get a session }
   SHandle := TMExtendedStartSession(PortNum,PortType,nil);
   If (SHandle > 0) Then
   Begin
      Light(True); { Turn the light on }

      { depending on sub-mode write different part of register }
      { write time,time alarm, temp thresholds }
      If (WriteMissionMode = WM_WRITE_TIME) Then
      Begin
         { check if setting real time clock }
         If (SetTimeCheck.Checked) Then
         Begin
            offset := $00;
            addr := $0200;
            len := 13;
         End
         Else
         Begin
            offset := $07;
            addr := $0207;
            len := 6;
         End;
      End
      { write control, start delay }
      Else If (WriteMissionMode = WM_WRITE_CONTROL) Then
      Begin
         offset := $0E;
         addr := $020E;
         len := 7;  { clear status also 3.11B4 }
      End
      { write the sample rate WM_WRITE_SAMPLE}
      Else
      Begin
         offset := $0D;
         addr := $020D;
         len := 1;
      End;

      { write the data  }
      flag := WriteScratch(@WriteStatusBuf[offset],len,addr);
      If (flag = TRECSUCCESS) Then
      Begin
         flag := CopyScratch(len,addr);
         If (flag = TRECSUCCESS) Then
            rt := TRECSUCCESS
         Else
            rt := flag;
      End
      Else
         rt := flag;

      { close the opened session }
      TMEndSession(SHandle);
      Light(False);  { Turn the light off }
   End
   Else
      rt := TRECNO_SESSION;

   WriteMission := rt;
End;

{----------------------------------------------------------------------------}
{ Write the scratch pad
}
Function TTRecForm.WriteScratch(Buf : PChar; ln,adr : SmallInt) : SmallInt;
Var
   rt,i : SmallInt;
   pbuf : array[0..40] of Byte;
Begin
   rt := TRECSUCCESS;
   { check for alarm indicator }
   If (TMStrongAccess(SHandle,StateBuf) = 1) Then
   Begin
      { construct a packet to send (3.10) }
      pbuf[0] := $0F; { write scratch command }
      pbuf[1] := (adr And $FF); { address 1 }
      pbuf[2] := ((adr shr 8) And $FF); { address 2 }

      { the write bytes }
      For i := 0 to ln-1 Do
        pbuf[3 + i] := Byte(Buf[i]); { data }

      { perform the block }
      If (TMBlockStream(SHandle,@pbuf[0],ln+3) <> (ln+3)) Then
      Begin
         rt := TRECNO_DEVICE;
      End;

      { Now read back the scratch }
      If (TMAccess(SHandle,StateBuf) = 1) Then
      Begin
         { construct a packet to send (3.10) }
         pbuf[0] := $AA; { read scratch command }
         pbuf[1] := $FF; { address 1 }
         pbuf[2] := $FF; { address 2 }
         pbuf[3] := $FF; { offset }

         { the write bytes }
         For i := 0 to ln-1 Do
            pbuf[4 + i] := $FF; { data }

         { perform the block  }
         If (TMBlockStream(SHandle,@pbuf[0],ln+4) <> (ln+4)) Then
         Begin
            rt := TRECNO_DEVICE;
         End;

         { read address 1 }
         If (pbuf[1] <> (adr And $FF)) Then
            rt := TREC_WRITE_ERR;
         { read address 2 }
         If (pbuf[2] <> ((adr shr 8) And $FF)) Then
            rt := TREC_WRITE_ERR;
         { read the offset }
         If (pbuf[3] <> ((adr + ln - 1) And $1F)) Then
            rt := TREC_WRITE_ERR;
         { read and compare the contents }
         For i := 0 to ln-1 Do
            If (pbuf[4 + i] <> SmallInt(Buf[i])) Then
            Begin
               rt := TREC_WRITE_ERR;
               Break;
            End;
      End;
   End
   Else
      rt := TRECNO_DEVICE;

   WriteScratch := rt;
End;

{----------------------------------------------------------------------------}
{ Copy the scratch pad
}
Function TTRecForm.CopyScratch(ln,adr : SmallInt) : SmallInt;
Var
   rt,i : SmallInt;
   pbuf : array[0..20] of Byte;
Begin
   rt := TRECNO_DEVICE; { 3.11 }
   { check for alarm indicator }
   If (TMAccess(SHandle,StateBuf) = 1) Then
   Begin
      { construct a packet to send (3.10) }
      pbuf[0] := $55; { copy scratch command }
      pbuf[1] := (adr And $FF); { address 1 }
      pbuf[2] := ((adr shr 8) And $FF); { address 2 }
      pbuf[3] := (adr + ln - 1) And $1F; { offset }
      For i := 0 to 9 Do
         pbuf[4 + i] := $FF; { result of copy }

      { perform the block }
      If (TMBlockStream(SHandle,@pbuf[0],14) = 14) Then
      Begin
         If ((pbuf[13] = $55) Or
             (pbuf[13] = $AA)) Then
           rt := TRECSUCCESS
      End;
   End;

   CopyScratch := rt;
End;

{----------------------------------------------------------------------------}
{ Export the data to a text file
}
procedure TTRecForm.ExportButtonClick(Sender: TObject);
Begin
   ExportData(False);
End;

{----------------------------------------------------------------------------}
{ Export data to a file or clipboard
}
procedure TTRecForm.ExportData(ToClipboard : Boolean);
Var
   TempStrs : TStrings;
   i,maxlog,ps : SmallInt;
   SaveOk : Boolean;
   tstr : String;
   TempBuf : PChar;
begin
   { create the string list }
   TempStrs := TStringList.Create;
   Try
      { optionally execute the dialog }
      If (Not ToClipboard) Then
      Begin
         SaveOk := SaveDialog.Execute;
         SaveDialog.InitialDir :=  ExtractFilePath(SaveDialog.FileName);
      End
      Else
         SaveOk := True;
      { optionally continue with save }
      If (SaveOk) Then
      Begin
         { add the rom number }
         TempStrs.Add(Caption);
         { add the current date }
         TempStrs.Add('Download at: ' + DateTimeToStr(DownloadTimeDate));
         TempStrs.Add('');
         { mission state }
         TempStrs.Add('Mission State');
         TempStrs.Add('-------------');
         TempStrs.Add('Mission is ' + MissionStatus.Caption);
         TempStrs.Add('Sample rate: ' + SampleRateLabel.Caption + ' minute(s)');
         TempStrs.Add('Roll-Over Enabled: ' + RolloverEnableLabel.Caption);
         TempStrs.Add('Roll-Over Occured: ' + RolloverOccuredLabel.Caption);
         TempStrs.Add('Mission Start time: ' + MissionStartLabel.Caption);
         TempStrs.Add('Mission Start delay: ' + MissionDelayLabel.Caption + ' minute(s)');
         TempStrs.Add('Mission Samples: ' + MissionSamplesLabel.Caption);
         TempStrs.Add('Device total samples: ' + DeviceCountLabel.Caption);
         TempStrs.Add('Temperatures displayed in: ' + DegreeLabel.Caption);
         TempStrs.Add('High Threshold: ' + HighThresholdLabel.Caption);
         TempStrs.Add('Low Threshold: ' + LowThresholdLabel.Caption);
         TempStrs.Add('Temperature threshold alarm state: ' + TempAlarmLabel.Caption);
         TempStrs.Add('Current Real-Time Clock from DS1921: ' + TRecTimeLabel.Caption);
         TempStrs.Add('Current PC Time: ' + PCTimeLabel.Caption);
         TempStrs.Add('Time Alarm mode: ' + AlarmModeLabel.Caption);
         TempStrs.Add('Alarm Time: ' + TimeAlarmSettingLabel.Caption);
         TempStrs.Add('Alarm Time state: ' + TimeAlarmLabel.Caption);
         TempStrs.Add('');
         { Alarms }
         TempStrs.Add('Temperature Alarms');
         TempStrs.Add('------------------');
         If (LogRadio.ItemIndex = 0) Then
            TempStrs.Add('Format: [(HIGH/LOW)' + Delimiter + 'Time/Date range]')
         Else
            TempStrs.Add('Format: [(HIGH/LOW)' + Delimiter + 'Minute Offset range]');
         For i := 0 to (AlarmList.Items.Count - 1) Do
         Begin
            If ((LogRadio.ItemIndex = 0) And (AlarmList.Items.Count > 1)) Then
            Begin
               { skip every other entry if two line format }
               If (((i + 1) mod 2) = 0) Then
                  continue;
               tstr := AlarmList.Items[i] + ' ' + AlarmList.Items[i + 1];
               { remove the 'start:' and 'end:' from the string }
               Delete(tstr,Pos('start:',tstr),6);
               ps := Pos('            end:',tstr);
               Delete(tstr,ps,16);
               Insert('to',tstr,ps);
               TempStrs.Add(tstr);
            End
            Else
               TempStrs.Add(AlarmList.Items[i]);
         End;
         TempStrs.Add('');
         { Histogram }
         TempStrs.Add('Temperature Histogram');
         TempStrs.Add('---------------------');
         TempStrs.Add('Format: [' + HistSyntax.Caption + '] ' + DegreeLabel.Caption);
         For i := 0 to (HistList.Items.Count - 1) Do
         Begin
            TempStrs.Add(HistList.Items[i]);
         End;
         TempStrs.Add('');
         { Log data }
         TempStrs.Add('Log Data');
         TempStrs.Add('--------');
         TempStrs.Add('Format: [' + LogSyntax.Caption + '] ' + DegreeLabel.Caption);
         For i := 0 to (LogList.Items.Count - 1) Do
         Begin
            TempStrs.Add(LogList.Items[i]);
         End;
         TempStrs.Add('');
         { check for debug dump }
         If (MenuDebugDump.Checked) Then
         Begin
            TempStrs.Add('Debug Dump (optional)');
            TempStrs.Add('---------------------');
            TempStrs.Add('Register Page:');
            tstr := '';
            For i := 0 to 31 Do
            Begin
               tstr := tstr + IntToHex(StatusBuf[i],2) + ' ';
               If (i = 15) Then
               Begin
                 TempStrs.Add(tstr);
                 tstr := '';
               End;
            End;
            If (Length(tstr) > 0) Then
               TempStrs.Add(tstr);
            TempStrs.Add('Alarms:');
            tstr := '';
            For i := 0 to 95 Do
            Begin
               tstr := tstr + IntToHex(TempAlarms[i],2) + ' ';
               If ((((i + 1) Mod 16) = 0) And (i <> 0)) Then
               Begin
                 TempStrs.Add(tstr);
                 tstr := '';
               End;
            End;
            If (Length(tstr) > 0) Then
               TempStrs.Add(tstr);
            TempStrs.Add('Histogram:');
            tstr := '';
            For i := 0 to 127 Do  { 3.12 }
            Begin
               tstr := tstr + IntToHex(Histogram[i],2) + ' ';
               If ((((i + 1) Mod 16) = 0) And (i <> 0)) Then
               Begin
                 TempStrs.Add(tstr);
                 tstr := '';
               End;
            End;
            If (Length(tstr) > 0) Then
               TempStrs.Add(tstr);
            TempStrs.Add('Log:');
            If (LastMissionCount > 2048) Then
               maxlog := 2047
            Else
               maxlog := LastMissionCount - 1;
            tstr := '';
            For i := 0 to maxlog Do
            Begin
               tstr := tstr + IntToHex(TempLog[i],2) + ' ';
               If ((((i + 1) Mod 16) = 0) And (i <> 0)) Then
               Begin
                 TempStrs.Add(tstr);
                 tstr := '';
               End;
            End;
            TempStrs.Add(tstr);
         End;
         { save it to the selected file or copy to clip board }
         If (Not ToClipboard) Then
            TempStrs.SaveToFile(SaveDialog.FileName)
         Else
         Begin
            { get a PChar text buf from listbox }
            TempBuf := TempStrs.GetText;
            {$IFNDEF WIN32}
            { check for too big of a buffer in 16-bit }
            If (StrLen(TempBuf) > 32000) Then
            Begin
               Application.MessageBox('WARNING, size of buffer exceeds maximum, data will be truncated!',
                       AppName, mb_OK + mb_IconExclamation + mb_ApplModal);
               TempBuf[32000] := Char(0);
            End;
            {$ENDIF}
            { put in clipboard }
            Clipboard.SetTextBuf(TempBuf);
         End;
      End;
   Finally
      { free up the string list memory }
      TempStrs.Free;
   End;
End;

{----------------------------------------------------------------------------}
{ Toggle debug dump in export file
}
procedure TTRecForm.MenuDebugDumpClick(Sender: TObject);
begin
   MenuDebugDump.Checked := Not MenuDebugDump.Checked;
end;

{----------------------------------------------------------------------------}
{ Export data to clipboard
}
procedure TTRecForm.MenuExportToClipClick(Sender: TObject);
begin
   ExportData(True);
end;

{----------------------------------------------------------------------------}
{ Show F/C toggle
}
procedure TTRecForm.MenuShowFCClick(Sender: TObject);
begin
   MenuShowFC.Checked := Not MenuShowFC.Checked;
   If (LogBox.Visible) Then
      UpdateLog;
   If (HistogramBox.Visible) Then
      UpdateHistogram;
   If (AlarmBox.Visible) Then
      UpdateAlarms;
   UpdateStatus;
end;

{----------------------------------------------------------------------------}
{ Command to stop the current mission
}
procedure TTRecForm.MenuStopMissionClick(Sender: TObject);
begin
   If ((TRECMode = TREC_READTIME) Or (TRECMode = TREC_VERIFY)) Then
      TRECMode := TREC_STOP_MISSION;
end;

{----------------------------------------------------------------------------}
{ Command to stop the current mission
}
Function TTRecForm.StopMission: SmallInt;
Var
   flag,rt : SmallInt;
   TempBuf : array[0..3] of Byte;
Begin
   TempBuf[0] := 0;

   {attempt to get a session }
   SHandle := TMExtendedStartSession(PortNum,PortType,nil);
   If (SHandle > 0) Then
   Begin
      Light(True); { Turn the light on }

      { write the data  }
      flag := WriteScratch(@TempBuf[0],1,$0214);
      If (flag = TRECSUCCESS) Then
      Begin
         flag := CopyScratch(1,$0214);
         If (flag = TRECSUCCESS) Then
            rt := TRECSUCCESS
         Else
            rt := flag;
      End
      Else
         rt := flag;

      { close the opened session }
      TMEndSession(SHandle);
      Light(False);  { Turn the light off }
   End
   Else
      rt := TRECNO_SESSION;

   StopMission := rt;
End;

{----------------------------------------------------------------------------}
{ Send conversion command
}
Function TTRecForm.ForceConversion: SmallInt;
Var
   flag,rt : SmallInt;
   TempBuf : array[0..3] of Byte;
Begin
   TempBuf[0] := 0;

   {attempt to get a session }
   SHandle := TMExtendedStartSession(PortNum,PortType,nil);
   If (SHandle > 0) Then
   Begin
      Light(True); { Turn the light on }

      { write the data  }
      flag := TMAccess(SHandle,StateBuf);
      If (flag = 1) Then
      Begin
         flag := TMTouchByte(SHandle,$44);
         if (flag = $44) Then
            rt := TRECSUCCESS
         Else
            rt := flag;
      End
      Else
         rt := flag;

      { close the opened session }
      TMEndSession(SHandle);
      Light(False);  { Turn the light off }
   End
   Else
      rt := TRECNO_SESSION;

   ForceConversion := rt;
End;

{----------------------------------------------------------------------------}
{ Convert C string to an integer.  Provide a default if an exception
  occures
}
Function TTRecForm.ConvertToInt(Buf : PChar; Def: LongInt): LongInt;
Begin
   Try
      ConvertToInt := StrToInt(StrPas(Buf));
   Except
      ConvertToInt := Def;
   End;
End;

{----------------------------------------------------------------------------}
{ Toggle auto export option
}
procedure TTRecForm.MenuAutoExportClick(Sender: TObject);
begin
   MenuAutoExport.Checked := Not MenuAutoExport.Checked;
end;

{----------------------------------------------------------------------------}
{ Start Help
}
procedure TTRecForm.MenuHelpClick(Sender: TObject);
begin
   Application.HelpCommand(HELP_CONTEXT, 13);
end;

{----------------------------------------------------------------------------}
{ Set Data delimiter  (new for V3.20)
}
procedure TTRecForm.RadioGroupDelimitersClick(Sender: TObject);
begin
   if RadioGroupDelimiters.ItemIndex = 0 Then Delimiter := ', '
   Else If RadioGroupDelimiters.ItemIndex = 1 Then Delimiter := '; ';
   UpdateHistogram;
   UpdateLog;
   UpdateAlarms;
   UpdateLabels;
end;

{-----------------------------------------------------------------
  Find the first device with the family type 'family'
}
function TTRecForm.FindFirstFamily(family: SmallInt;
           Var ROMStr: String): SmallInt;
Var
   j,rt : SmallInt;
Begin
   { default return }
   rt := TRECNO_DEVICE;
   {attempt to get a session }
   SHandle := TMExtendedStartSession(PortNum,PortType,nil);
   If (SHandle > 0) Then
   Begin
      Light(True); { Turn the light on }

      { check if did setup }
      If (Not DidSetup) Then
      Begin
         if (TMSetup(SHandle) <> 1) Then
         Begin
            Application.MessageBox('Error, setting up default 1-Wire Net',
                     AppName, mb_OK + mb_IconExclamation + mb_ApplModal);
            Application.Terminate;
         End;
         DidSetup := True;
      End;

      { set up to find the first device with family family }
      If (TMFamilySearchSetup(SHandle,Statebuf,family) = 1) Then
      Begin
         { get first device in list with the specified family }
         If (TMNext(SHandle,Statebuf) = 1) Then
         Begin
            { read the rom number }
            ROM[0] := 0;
            TMRom(SHandle,Statebuf,@ROM);

            { check if correct type }
            If ((family And $7F) = (ROM[0] And $7F)) Then
            Begin
               ROMStr := '';
               For j := 7 downto 0 do
                  ROMStr := ROMStr + Format('%.2X',[ROM[j]]);
               rt := TRECSUCCESS
            End;
         End;
      End;
      { close the opened session }
      TMEndSession(SHandle);
      Light(False);  { Turn the light off }
   End
   Else
      rt := TRECNO_SESSION;

   { set return value }
   FindFirstFamily := rt;
End;

{----------------------------------------------------------------------------}
{ Update certain form labels with new Data delimiter  (new for V3.20)
}
procedure TTRecForm.UpdateLabels;
Var
   LogSyntaxStr, HistSyntaxStr, OldDelimiter : String;
   OldDelimiterOffset : Integer;
begin
   { Find out what OldDelimiter was }
   If (AnsiCompareStr('; ', Delimiter) = 0) Then OldDelimiter := ', '
   Else OldDelimiter := '; ';
   LogSyntaxStr := LogSyntax.Caption;
   HistSyntaxStr := HistSyntax.Caption;
   OldDelimiterOffset := AnsiPos(OldDelimiter, LogSyntaxStr);
   { Change string with new Delimiter for LogSyntax }
   If OldDelimiterOffset > 0 Then
   Begin
       Delete(LogSyntaxStr, OldDelimiterOffset, 2);
       Insert(Delimiter, LogSyntaxStr, OldDelimiterOffset);
   End;
   LogSyntax.Caption := LogSyntaxStr;
   { Change string with new Delimiter for HistSyntax }
   OldDelimiterOffset := AnsiPos(OldDelimiter, HistSyntaxStr);
   { Change string with new Delimiter }
   If OldDelimiterOffset > 0 Then
   Begin
       Delete(HistSyntaxStr, OldDelimiterOffset, 2);
       Insert(Delimiter, HistSyntaxStr, OldDelimiterOffset);
   End;
   HistSyntax.Caption := HistSyntaxStr;

end;


procedure TTRecForm.FormShow(Sender: TObject);
begin
   TRecForm.DisplayThermoType;
end;

procedure TTRecForm.DisplayThermoType;
var
   code : Integer;   { V3.20 Release }
begin
   { V3.20 Release}
   { The following code must be in FormShow and NOT FormCreate }
   { Extract Temperature range of device from ROM code V3.20 release }
   { Assume high temperature limit to be 85 degrees Celsius          }
   { See page 36 of the DS1921 data sheet }

   Code := ((ROM[6] shl 8) or ROM[5]) shr 4;
   If Code = $00 Then Code := $64;  { For original samples }
   { Assume high temperature to be 85 degrees Celsius }
   TempRangeHigh := 85;
   { Calculate low temperature from Code and Tu }
   TempRangeLow := ((5*Code div 4) - TempRangeHigh - 1280) div 31;
   TempResolution := 0.5;
   TempZero := -40.0;
   { check for DS1921H and DS1921Z }
   If Code = $4F2 Then
   Begin
      TempRangeHigh := 46;
      TempRangeLow := 15;
      TempResolution := 0.125;
      TempZero := 14.5;
   End
   Else If Code = $3B2 Then
   Begin
      TempRangeHigh := 26;
      TempRangeLow := -5;
      TempResolution := 0.125;
      TempZero := -5.5;
   End;

   LabelTempRange.Caption := ' ' + IntToStr(TempRangeLow) + 'C to ' + IntToStr(TempRangeHigh) + 'C';
   LabelTempRange.Visible := True;
end;


end.
